/* This file was generated by SableCC (http://www.sablecc.org/). */

package decasyntax.lexer;

import java.io.*;
import decasyntax.node.*;

@SuppressWarnings("nls")
public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    @SuppressWarnings("unused")
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    public Lexer(@SuppressWarnings("hiding") PushbackReader in)
    {
        this.in = in;
    }
 
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.token = getToken();
            filter();
        }

        return this.token;
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.token = getToken();
            filter();
        }

        Token result = this.token;
        this.token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        @SuppressWarnings("hiding") int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
        @SuppressWarnings("hiding") int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            @SuppressWarnings("hiding") Token token = new0(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            @SuppressWarnings("hiding") Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            @SuppressWarnings("hiding") Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            @SuppressWarnings("hiding") Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            @SuppressWarnings("hiding") Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            @SuppressWarnings("hiding") Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            @SuppressWarnings("hiding") Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            @SuppressWarnings("hiding") Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            @SuppressWarnings("hiding") Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            @SuppressWarnings("hiding") Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            @SuppressWarnings("hiding") Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            @SuppressWarnings("hiding") Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            @SuppressWarnings("hiding") Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            @SuppressWarnings("hiding") Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            @SuppressWarnings("hiding") Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            @SuppressWarnings("hiding") Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            @SuppressWarnings("hiding") Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            @SuppressWarnings("hiding") Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            @SuppressWarnings("hiding") Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            @SuppressWarnings("hiding") Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            @SuppressWarnings("hiding") Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            @SuppressWarnings("hiding") Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            @SuppressWarnings("hiding") Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            @SuppressWarnings("hiding") Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                            @SuppressWarnings("hiding") Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                            @SuppressWarnings("hiding") Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                            @SuppressWarnings("hiding") Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                            @SuppressWarnings("hiding") Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                            @SuppressWarnings("hiding") Token token = new28(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                            @SuppressWarnings("hiding") Token token = new29(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                            @SuppressWarnings("hiding") Token token = new30(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                            @SuppressWarnings("hiding") Token token = new31(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                            @SuppressWarnings("hiding") Token token = new32(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                            @SuppressWarnings("hiding") Token token = new33(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                            @SuppressWarnings("hiding") Token token = new34(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 35:
                        {
                            @SuppressWarnings("hiding") Token token = new35(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 36:
                        {
                            @SuppressWarnings("hiding") Token token = new36(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 37:
                        {
                            @SuppressWarnings("hiding") Token token = new37(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 38:
                        {
                            @SuppressWarnings("hiding") Token token = new38(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 39:
                        {
                            @SuppressWarnings("hiding") Token token = new39(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 40:
                        {
                            @SuppressWarnings("hiding") Token token = new40(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 41:
                        {
                            @SuppressWarnings("hiding") Token token = new41(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 42:
                        {
                            @SuppressWarnings("hiding") Token token = new42(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 43:
                        {
                            @SuppressWarnings("hiding") Token token = new43(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 44:
                        {
                            @SuppressWarnings("hiding") Token token = new44(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 45:
                        {
                            @SuppressWarnings("hiding") Token token = new45(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 46:
                        {
                            @SuppressWarnings("hiding") Token token = new46(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 47:
                        {
                            @SuppressWarnings("hiding") Token token = new47(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 48:
                        {
                            @SuppressWarnings("hiding") Token token = new48(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 49:
                        {
                            @SuppressWarnings("hiding") Token token = new49(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 50:
                        {
                            @SuppressWarnings("hiding") Token token = new50(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 51:
                        {
                            @SuppressWarnings("hiding") Token token = new51(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 52:
                        {
                            @SuppressWarnings("hiding") Token token = new52(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 53:
                        {
                            @SuppressWarnings("hiding") Token token = new53(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 54:
                        {
                            @SuppressWarnings("hiding") Token token = new54(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 55:
                        {
                            @SuppressWarnings("hiding") Token token = new55(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 56:
                        {
                            @SuppressWarnings("hiding") Token token = new56(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 57:
                        {
                            @SuppressWarnings("hiding") Token token = new57(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 58:
                        {
                            @SuppressWarnings("hiding") Token token = new58(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 59:
                        {
                            @SuppressWarnings("hiding") Token token = new59(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 60:
                        {
                            @SuppressWarnings("hiding") Token token = new60(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 61:
                        {
                            @SuppressWarnings("hiding") Token token = new61(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 62:
                        {
                            @SuppressWarnings("hiding") Token token = new62(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 63:
                        {
                            @SuppressWarnings("hiding") Token token = new63(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 64:
                        {
                            @SuppressWarnings("hiding") Token token = new64(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 65:
                        {
                            @SuppressWarnings("hiding") Token token = new65(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 66:
                        {
                            @SuppressWarnings("hiding") Token token = new66(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 67:
                        {
                            @SuppressWarnings("hiding") Token token = new67(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 68:
                        {
                            @SuppressWarnings("hiding") Token token = new68(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 69:
                        {
                            @SuppressWarnings("hiding") Token token = new69(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 70:
                        {
                            @SuppressWarnings("hiding") Token token = new70(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    case 71:
                        {
                            @SuppressWarnings("hiding") Token token = new71(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                    @SuppressWarnings("hiding") EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TGlobalVariableModifier(line, pos); }
    Token new1(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TPublicityModifier(text, line, pos); }
    Token new2(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TBooleanConstant(text, line, pos); }
    Token new3(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TModuleModifier(text, line, pos); }
    Token new4(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TMultiplicationOperator(line, pos); }
    Token new5(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TDivisionOperator(line, pos); }
    Token new6(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TAdditionOperator(line, pos); }
    Token new7(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TSubtractionOperator(line, pos); }
    Token new8(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TAndOperator(line, pos); }
    Token new9(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TOrOperator(line, pos); }
    Token new10(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TXorOperator(line, pos); }
    Token new11(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TMinusOperator(line, pos); }
    Token new12(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TExponentiationOperator(line, pos); }
    Token new13(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TApplyOperator(line, pos); }
    Token new14(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TAtOperator(line, pos); }
    Token new15(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TNotOperator(line, pos); }
    Token new16(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TGeneric(line, pos); }
    Token new17(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TMethod(line, pos); }
    Token new18(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TComma(line, pos); }
    Token new19(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TAssignmentOperator(line, pos); }
    Token new20(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TLparen(line, pos); }
    Token new21(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TRparen(line, pos); }
    Token new22(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TLbracket(line, pos); }
    Token new23(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TRbracket(line, pos); }
    Token new24(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TLsbracket(line, pos); }
    Token new25(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TRsbracket(line, pos); }
    Token new26(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TDot(line, pos); }
    Token new27(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TSemicolon(line, pos); }
    Token new28(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TEndModule(line, pos); }
    Token new29(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TModule(line, pos); }
    Token new30(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TLabracket(line, pos); }
    Token new31(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TRabracket(line, pos); }
    Token new32(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TImport(line, pos); }
    Token new33(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TDefine(line, pos); }
    Token new34(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TConstructor(line, pos); }
    Token new35(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TDestructor(line, pos); }
    Token new36(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TExtends(line, pos); }
    Token new37(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TClassKeyword(line, pos); }
    Token new38(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TSubrange(line, pos); }
    Token new39(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TEnum(line, pos); }
    Token new40(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TException(line, pos); }
    Token new41(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TEquals(line, pos); }
    Token new42(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TDifferent(line, pos); }
    Token new43(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TGreatereq(line, pos); }
    Token new44(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TLessereq(line, pos); }
    Token new45(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TFunction(line, pos); }
    Token new46(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TLambda(line, pos); }
    Token new47(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TReturn(line, pos); }
    Token new48(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TWhile(line, pos); }
    Token new49(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TDo(line, pos); }
    Token new50(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TUntil(line, pos); }
    Token new51(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TFor(line, pos); }
    Token new52(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TCase(line, pos); }
    Token new53(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TCond(line, pos); }
    Token new54(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TLet(line, pos); }
    Token new55(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TExcept(line, pos); }
    Token new56(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TFinally(line, pos); }
    Token new57(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TTry(line, pos); }
    Token new58(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TThrow(line, pos); }
    Token new59(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TElse(line, pos); }
    Token new60(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TCast(line, pos); }
    Token new61(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TAliasOperator(line, pos); }
    Token new62(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TType(line, pos); }
    Token new63(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TClosure(line, pos); }
    Token new64(@SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TNullLiteral(line, pos); }
    Token new65(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TBlank(text, line, pos); }
    Token new66(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TTabspace(text, line, pos); }
    Token new67(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TSpace(text, line, pos); }
    Token new68(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TComment(text, line, pos); }
    Token new69(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TUnqualifiedIdentifier(text, line, pos); }
    Token new70(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TIntegerConstant(text, line, pos); }
    Token new71(@SuppressWarnings("hiding") String text, @SuppressWarnings("hiding") int line, @SuppressWarnings("hiding") int pos) { return new TStringConstant(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(@SuppressWarnings("hiding") Token token) throws IOException
    {
        @SuppressWarnings("hiding") String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {33, 33, 5}, {34, 34, 6}, {38, 38, 7}, {40, 40, 8}, {41, 41, 9}, {42, 42, 10}, {43, 43, 11}, {44, 44, 12}, {45, 45, 13}, {46, 46, 14}, {47, 47, 15}, {48, 48, 16}, {49, 57, 17}, {58, 58, 18}, {59, 59, 19}, {60, 60, 20}, {61, 61, 21}, {62, 62, 22}, {63, 63, 23}, {64, 64, 24}, {65, 90, 25}, {91, 91, 26}, {93, 93, 27}, {94, 94, 28}, {95, 95, 29}, {97, 97, 30}, {98, 98, 31}, {99, 99, 32}, {100, 100, 33}, {101, 101, 34}, {102, 102, 35}, {103, 103, 36}, {104, 104, 31}, {105, 105, 37}, {106, 107, 31}, {108, 108, 38}, {109, 109, 39}, {110, 110, 40}, {111, 111, 41}, {112, 112, 42}, {113, 113, 31}, {114, 114, 43}, {115, 115, 44}, {116, 116, 45}, {117, 117, 46}, {118, 118, 31}, {119, 119, 47}, {120, 120, 48}, {121, 122, 31}, {123, 123, 49}, {125, 125, 50}, {127, 255, 51}, },
            {},
            {},
            {{10, 10, 52}, },
            {},
            {{33, 33, 53}, {48, 57, 54}, {63, 63, 55}, {65, 90, 56}, {95, 95, 57}, {97, 122, 58}, {127, 255, 59}, },
            {{0, 9, 60}, {11, 12, 60}, {14, 33, 60}, {34, 34, 61}, {35, 91, 60}, {92, 92, 62}, {93, 65535, 60}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{62, 62, 63}, },
            {},
            {{42, 42, 64}, },
            {{48, 55, 65}, {120, 120, 66}, },
            {{48, 57, 67}, },
            {{61, 61, 68}, },
            {},
            {{61, 61, 69}, {62, 62, 70}, },
            {},
            {{61, 61, 71}, },
            {{33, 255, -7}, },
            {},
            {{33, 255, -7}, },
            {},
            {},
            {},
            {{33, 255, -7}, },
            {{33, 95, -7}, {97, 109, 58}, {110, 110, 72}, {111, 122, 58}, {127, 255, 59}, },
            {{33, 255, -7}, },
            {{33, 95, -7}, {97, 97, 73}, {98, 107, 58}, {108, 108, 74}, {109, 110, 58}, {111, 111, 75}, {112, 122, 58}, {127, 255, 59}, },
            {{33, 95, -7}, {97, 100, 58}, {101, 101, 76}, {102, 110, 58}, {111, 111, 77}, {112, 255, -34}, },
            {{33, 95, -7}, {97, 107, 58}, {108, 108, 78}, {109, 109, 58}, {110, 110, 79}, {111, 119, 58}, {120, 120, 80}, {121, 122, 58}, {127, 255, 59}, },
            {{33, 95, -7}, {97, 97, 81}, {98, 104, 58}, {105, 105, 82}, {106, 110, 58}, {111, 111, 83}, {112, 116, 58}, {117, 117, 84}, {118, 122, 58}, {127, 255, 59}, },
            {{33, 100, -35}, {101, 101, 85}, {102, 122, 58}, {127, 255, 59}, },
            {{33, 95, -7}, {97, 108, 58}, {109, 109, 86}, {110, 122, 58}, {127, 255, 59}, },
            {{33, 95, -7}, {97, 97, 87}, {98, 100, 58}, {101, 101, 88}, {102, 255, -38}, },
            {{33, 100, -35}, {101, 101, 89}, {102, 110, 58}, {111, 111, 90}, {112, 255, -34}, },
            {{33, 95, -7}, {97, 110, 58}, {111, 111, 91}, {112, 116, 58}, {117, 117, 92}, {118, 255, -37}, },
            {{33, 95, -7}, {97, 113, 58}, {114, 114, 93}, {115, 122, 58}, {127, 255, 59}, },
            {{33, 113, -43}, {114, 114, 94}, {115, 116, 58}, {117, 117, 95}, {118, 255, -37}, },
            {{33, 100, -35}, {101, 101, 96}, {102, 255, -38}, },
            {{33, 95, -7}, {97, 116, 58}, {117, 117, 97}, {118, 255, -37}, },
            {{33, 95, -7}, {97, 103, 58}, {104, 104, 98}, {105, 113, 58}, {114, 114, 99}, {115, 120, 58}, {121, 121, 100}, {122, 122, 58}, {127, 255, 59}, },
            {{33, 109, -32}, {110, 110, 101}, {111, 255, -32}, },
            {{33, 103, -47}, {104, 104, 102}, {105, 122, 58}, {127, 255, 59}, },
            {{33, 110, -42}, {111, 111, 103}, {112, 255, -34}, },
            {},
            {},
            {{33, 255, -7}, },
            {},
            {{33, 255, -7}, },
            {{33, 255, -7}, },
            {{33, 255, -7}, },
            {{33, 255, -7}, },
            {{33, 255, -7}, },
            {{33, 255, -7}, },
            {{33, 255, -7}, },
            {{0, 65535, -8}, },
            {},
            {{34, 34, 104}, {39, 39, 105}, {48, 51, 106}, {52, 55, 107}, {92, 92, 108}, {98, 98, 109}, {102, 102, 110}, {110, 110, 111}, {114, 114, 112}, {116, 116, 113}, },
            {},
            {{0, 41, 114}, {42, 42, 115}, {43, 65535, 114}, },
            {{48, 55, 65}, },
            {{48, 57, 116}, {65, 70, 117}, {97, 102, 118}, },
            {{48, 57, 67}, },
            {},
            {},
            {},
            {},
            {{33, 95, -7}, {97, 99, 58}, {100, 100, 119}, {101, 122, 58}, {127, 255, 59}, },
            {{33, 95, -7}, {97, 114, 58}, {115, 115, 120}, {116, 122, 58}, {127, 255, 59}, },
            {{33, 95, -7}, {97, 97, 121}, {98, 110, 58}, {111, 111, 122}, {112, 255, -34}, },
            {{33, 109, -32}, {110, 110, 123}, {111, 255, -32}, },
            {{33, 95, -7}, {97, 101, 58}, {102, 102, 124}, {103, 114, 58}, {115, 115, 125}, {116, 255, -75}, },
            {{33, 255, -7}, },
            {{33, 114, -75}, {115, 115, 126}, {116, 255, -75}, },
            {{33, 99, -74}, {100, 100, 127}, {101, 116, 58}, {117, 117, 128}, {118, 255, -37}, },
            {{33, 95, -7}, {97, 98, 58}, {99, 99, 129}, {100, 115, 58}, {116, 116, 130}, {117, 122, 58}, {127, 255, 59}, },
            {{33, 107, -36}, {108, 108, 131}, {109, 122, 58}, {127, 255, 59}, },
            {{33, 109, -32}, {110, 110, 132}, {111, 255, -32}, },
            {{33, 113, -43}, {114, 114, 133}, {115, 255, -43}, },
            {{33, 109, -32}, {110, 110, 134}, {111, 255, -32}, },
            {{33, 109, -32}, {110, 110, 135}, {111, 255, -32}, },
            {{33, 95, -7}, {97, 111, 58}, {112, 112, 136}, {113, 122, 58}, {127, 255, 59}, },
            {{33, 108, -39}, {109, 109, 137}, {110, 255, -39}, },
            {{33, 95, -7}, {97, 115, 58}, {116, 116, 138}, {117, 255, -82}, },
            {{33, 115, -90}, {116, 116, 139}, {117, 255, -82}, },
            {{33, 99, -74}, {100, 100, 140}, {101, 255, -74}, },
            {{33, 115, -90}, {116, 116, 141}, {117, 255, -82}, },
            {{33, 107, -36}, {108, 108, 142}, {109, 255, -83}, },
            {{33, 255, -7}, },
            {{33, 110, -42}, {111, 111, 143}, {112, 255, -34}, },
            {{33, 95, -7}, {97, 97, 58}, {98, 98, 144}, {99, 113, 58}, {114, 114, 145}, {115, 255, -43}, },
            {{33, 115, -90}, {116, 116, 146}, {117, 255, -82}, },
            {{33, 97, -97}, {98, 98, 147}, {99, 122, 58}, {127, 255, 59}, },
            {{33, 113, -43}, {114, 114, 148}, {115, 255, -43}, },
            {{33, 116, -46}, {117, 117, 149}, {118, 120, 58}, {121, 121, 150}, {122, 255, -47}, },
            {{33, 111, -88}, {112, 112, 151}, {113, 255, -88}, },
            {{33, 114, -75}, {115, 115, 152}, {116, 116, 153}, {117, 255, -82}, },
            {{33, 95, -7}, {97, 104, 58}, {105, 105, 154}, {106, 122, 58}, {127, 255, 59}, },
            {{33, 113, -43}, {114, 114, 155}, {115, 255, -43}, },
            {{0, 65535, -8}, },
            {{0, 65535, -8}, },
            {{0, 34, -8}, {35, 47, 60}, {48, 55, 156}, {56, 91, 60}, {92, 65535, -8}, },
            {{0, 47, -108}, {48, 55, 157}, {56, 65535, -108}, },
            {{0, 65535, -8}, },
            {{0, 65535, -8}, },
            {{0, 65535, -8}, },
            {{0, 65535, -8}, },
            {{0, 65535, -8}, },
            {{0, 65535, -8}, },
            {{0, 65535, -66}, },
            {{0, 41, 158}, {42, 42, 115}, {43, 46, 158}, {47, 47, 159}, {48, 65535, 158}, },
            {{48, 102, -68}, },
            {{48, 102, -68}, },
            {{48, 102, -68}, },
            {{33, 255, -7}, },
            {{33, 100, -35}, {101, 101, 160}, {102, 115, 58}, {116, 116, 161}, {117, 255, -82}, },
            {{33, 114, -75}, {115, 115, 162}, {116, 255, -75}, },
            {{33, 114, -75}, {115, 115, 163}, {116, 255, -75}, },
            {{33, 99, -74}, {100, 100, 164}, {101, 114, 58}, {115, 115, 165}, {116, 255, -75}, },
            {{33, 104, -104}, {105, 105, 166}, {106, 255, -104}, },
            {{33, 115, -90}, {116, 116, 167}, {117, 255, -82}, },
            {{33, 100, -35}, {101, 101, 168}, {102, 255, -38}, },
            {{33, 33, 53}, {46, 46, 169}, {48, 255, -7}, },
            {{33, 108, -39}, {109, 109, 170}, {110, 255, -39}, },
            {{33, 100, -35}, {101, 101, 171}, {102, 255, -38}, },
            {{33, 100, -35}, {101, 101, 172}, {102, 255, -38}, },
            {{33, 114, -75}, {115, 115, 173}, {116, 255, -75}, },
            {{33, 95, -7}, {97, 97, 174}, {98, 122, 58}, {127, 255, 59}, },
            {{33, 255, -7}, },
            {{33, 98, -82}, {99, 99, 175}, {100, 122, 58}, {127, 255, 59}, },
            {{33, 100, -35}, {101, 101, 176}, {102, 255, -38}, },
            {{33, 110, -42}, {111, 111, 177}, {112, 255, -34}, },
            {{33, 97, -97}, {98, 98, 178}, {99, 255, -99}, },
            {{33, 255, -7}, },
            {{33, 103, -47}, {104, 104, 179}, {105, 255, -49}, },
            {{33, 116, -46}, {117, 117, 180}, {118, 255, -37}, },
            {{33, 255, -7}, },
            {{33, 107, -36}, {108, 108, 181}, {109, 255, -83}, },
            {{33, 115, -90}, {116, 116, 182}, {117, 255, -82}, },
            {{33, 107, -36}, {108, 108, 183}, {109, 255, -83}, },
            {{33, 100, -35}, {101, 101, 184}, {102, 255, -38}, },
            {{33, 116, -46}, {117, 117, 185}, {118, 255, -37}, },
            {{33, 113, -43}, {114, 114, 186}, {115, 255, -43}, },
            {{33, 110, -42}, {111, 111, 187}, {112, 255, -34}, },
            {{33, 100, -35}, {101, 101, 188}, {102, 255, -38}, },
            {{33, 255, -7}, },
            {{33, 100, -35}, {101, 101, 189}, {102, 255, -38}, },
            {{33, 95, -7}, {97, 97, 190}, {98, 255, -134}, },
            {{33, 104, -104}, {105, 105, 191}, {106, 255, -104}, },
            {{33, 107, -36}, {108, 108, 192}, {109, 255, -83}, },
            {{33, 255, -7}, },
            {{0, 47, -108}, {48, 55, 193}, {56, 65535, -108}, },
            {{0, 65535, -8}, },
            {{0, 41, 194}, {42, 42, 195}, {43, 65535, 194}, },
            {},
            {{33, 255, -7}, },
            {{33, 255, -7}, },
            {{33, 114, -75}, {115, 115, 196}, {116, 255, -75}, },
            {{33, 116, -46}, {117, 117, 197}, {118, 255, -37}, },
            {{33, 255, -7}, },
            {{33, 115, -90}, {116, 116, 198}, {117, 255, -82}, },
            {{33, 109, -32}, {110, 110, 199}, {111, 255, -32}, },
            {{33, 113, -43}, {114, 114, 200}, {115, 255, -43}, },
            {{33, 255, -7}, },
            {},
            {{33, 255, -7}, },
            {{33, 111, -88}, {112, 112, 201}, {113, 255, -88}, },
            {{33, 109, -32}, {110, 110, 202}, {111, 255, -32}, },
            {{33, 100, -35}, {101, 101, 203}, {102, 255, -38}, },
            {{33, 107, -36}, {108, 108, 204}, {109, 255, -83}, },
            {{33, 115, -90}, {116, 116, 205}, {117, 255, -82}, },
            {{33, 113, -43}, {114, 114, 206}, {115, 255, -43}, },
            {{33, 113, -43}, {114, 114, 207}, {115, 255, -43}, },
            {{33, 99, -74}, {100, 100, 208}, {101, 255, -74}, },
            {{33, 110, -42}, {111, 111, 209}, {112, 255, -34}, },
            {{33, 107, -36}, {108, 108, 210}, {109, 255, -83}, },
            {{33, 255, -7}, },
            {{33, 100, -35}, {101, 101, 211}, {102, 255, -38}, },
            {{33, 104, -104}, {105, 105, 212}, {106, 255, -104}, },
            {{33, 255, -7}, },
            {{33, 113, -43}, {114, 114, 213}, {115, 255, -43}, },
            {{33, 95, -7}, {97, 97, 214}, {98, 255, -134}, },
            {{33, 95, -7}, {97, 118, 58}, {119, 119, 215}, {120, 122, 58}, {127, 255, 59}, },
            {{33, 255, -7}, },
            {{33, 255, -7}, },
            {{33, 101, -78}, {102, 102, 216}, {103, 122, 58}, {127, 255, 59}, },
            {{33, 107, -36}, {108, 108, 217}, {109, 255, -83}, },
            {{33, 100, -35}, {101, 101, 218}, {102, 255, -38}, },
            {{0, 65535, -8}, },
            {{0, 65535, -160}, },
            {{0, 41, 158}, {42, 42, 195}, {43, 65535, -117}, },
            {{33, 255, -7}, },
            {{33, 113, -43}, {114, 114, 219}, {115, 255, -43}, },
            {{33, 95, -7}, {97, 97, 220}, {98, 113, 58}, {114, 114, 221}, {115, 255, -43}, },
            {{33, 100, -35}, {101, 101, 222}, {102, 255, -38}, },
            {{33, 116, -46}, {117, 117, 223}, {118, 255, -37}, },
            {{33, 115, -90}, {116, 116, 224}, {117, 255, -82}, },
            {{33, 99, -74}, {100, 100, 225}, {101, 255, -74}, },
            {{33, 255, -7}, },
            {{33, 107, -36}, {108, 108, 226}, {109, 255, -83}, },
            {{33, 104, -104}, {105, 105, 227}, {106, 255, -104}, },
            {{33, 104, -104}, {105, 105, 228}, {106, 255, -104}, },
            {{33, 115, -90}, {116, 116, 229}, {117, 255, -82}, },
            {{33, 95, -7}, {97, 97, 230}, {98, 255, -134}, },
            {{33, 99, -74}, {100, 100, 231}, {101, 255, -74}, },
            {{33, 100, -35}, {101, 101, 232}, {102, 255, -38}, },
            {{33, 98, -82}, {99, 99, 233}, {100, 255, -136}, },
            {{33, 98, -82}, {99, 99, 234}, {100, 255, -136}, },
            {{33, 109, -32}, {110, 110, 235}, {111, 255, -32}, },
            {{33, 109, -32}, {110, 110, 236}, {111, 255, -32}, },
            {{33, 255, -7}, },
            {{33, 100, -35}, {101, 101, 237}, {102, 255, -38}, },
            {{33, 255, -7}, },
            {{33, 255, -7}, },
            {{33, 100, -35}, {101, 101, 238}, {102, 255, -38}, },
            {{33, 109, -32}, {110, 110, 239}, {111, 255, -32}, },
            {{33, 116, -46}, {117, 117, 240}, {118, 255, -37}, },
            {{33, 255, -7}, },
            {{33, 98, -82}, {99, 99, 241}, {100, 255, -136}, },
            {{33, 104, -104}, {105, 105, 242}, {106, 255, -104}, },
            {{33, 114, -75}, {115, 115, 243}, {116, 255, -75}, },
            {{33, 95, -7}, {97, 120, 58}, {121, 121, 244}, {122, 255, -47}, },
            {{33, 110, -42}, {111, 111, 245}, {112, 255, -34}, },
            {{33, 98, -82}, {99, 99, 246}, {100, 255, -136}, },
            {{33, 255, -7}, },
            {{33, 255, -7}, },
            {{33, 255, -7}, },
            {{33, 255, -7}, },
            {{33, 115, -90}, {116, 116, 247}, {117, 255, -82}, },
            {{33, 255, -7}, },
            {{33, 255, -7}, },
            {{33, 95, -7}, {97, 102, 58}, {103, 103, 248}, {104, 122, 58}, {127, 255, 59}, },
            {{33, 255, -7}, },
            {{33, 255, -7}, },
            {{33, 115, -90}, {116, 116, 249}, {117, 255, -82}, },
            {{33, 98, -82}, {99, 99, 250}, {100, 255, -136}, },
            {{33, 115, -90}, {116, 116, 251}, {117, 255, -82}, },
            {{33, 110, -42}, {111, 111, 252}, {112, 255, -34}, },
            {{33, 255, -7}, },
            {{33, 255, -7}, },
            {{33, 109, -32}, {110, 110, 253}, {111, 255, -32}, },
            {{33, 255, -7}, },
            {{33, 100, -35}, {101, 101, 254}, {102, 255, -38}, },
            {{33, 100, -35}, {101, 101, 255}, {102, 255, -38}, },
            {{33, 255, -7}, },
            {{33, 115, -90}, {116, 116, 256}, {117, 255, -82}, },
            {{33, 110, -42}, {111, 111, 257}, {112, 255, -34}, },
            {{33, 109, -32}, {110, 110, 258}, {111, 255, -32}, },
            {{33, 255, -7}, },
            {{33, 99, -74}, {100, 100, 259}, {101, 255, -74}, },
            {{33, 255, -7}, },
            {{33, 110, -42}, {111, 111, 260}, {112, 255, -34}, },
            {{33, 113, -43}, {114, 114, 261}, {115, 255, -43}, },
            {{33, 255, -7}, },
            {{33, 255, -7}, },
            {{33, 113, -43}, {114, 114, 262}, {115, 255, -43}, },
            {{33, 255, -7}, },
            {{33, 255, -7}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {-1, 65, 65, 65, 65, 69, -1, 61, 20, 21, 4, 6, 18, 7, 26, 5, 70, 70, -1, 27, 30, 41, 31, 69, 14, 69, 24, 25, 12, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 22, 23, 69, 65, 69, 69, 69, 69, 69, 69, 69, -1, 71, -1, 13, -1, 70, -1, 70, 19, 44, 42, 43, 69, 69, 69, 69, 69, 49, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 9, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 70, 70, 70, 8, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 51, 69, 69, 69, 69, 54, 69, 69, 15, 69, 69, 69, 69, 69, 69, 69, 69, 57, 69, 69, 69, 69, 10, -1, -1, -1, 68, 52, 60, 69, 69, 53, 69, 69, 69, 59, 28, 39, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 64, 69, 69, 3, 69, 69, 69, 2, 62, 69, 69, 69, -1, -1, -1, 37, 69, 69, 69, 69, 69, 69, 2, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 69, 58, 69, 50, 48, 69, 69, 69, 33, 69, 55, 69, 69, 69, 69, 32, 46, 17, 29, 69, 1, 47, 69, 3, 63, 69, 69, 69, 69, 36, 56, 69, 16, 69, 69, 0, 69, 69, 69, 45, 69, 38, 69, 69, 40, 1, 69, 35, 34, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(@SuppressWarnings("hiding") int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
