/* This file was generated by SableCC (http://www.sablecc.org/). */

package decasyntax.parser;

import decasyntax.lexer.*;
import decasyntax.node.*;
import decasyntax.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

@SuppressWarnings("nls")
public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected ArrayList nodeList;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    public Parser(@SuppressWarnings("hiding") Lexer lexer)
    {
        this.lexer = lexer;
    }

    protected void filter() throws ParserException, LexerException, IOException
    {
        // Empty body
    }

    private void push(int numstate, ArrayList listNode, boolean hidden) throws ParserException, LexerException, IOException
    {
        this.nodeList = listNode;

        if(!hidden)
        {
            filter();
        }

        if(!this.stack.hasNext())
        {
            this.stack.add(new State(numstate, this.nodeList));
            return;
        }

        State s = (State) this.stack.next();
        s.state = numstate;
        s.nodes = this.nodeList;
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private int state()
    {
        State s = (State) this.stack.previous();
        this.stack.next();
        return s.state;
    }

    private ArrayList pop()
    {
        return ((State) this.stack.previous()).nodes;
    }

    private int index(Switchable token)
    {
        this.converter.index = -1;
        token.apply(this.converter);
        return this.converter.index;
    }

    @SuppressWarnings("unchecked")
    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, true);
        List<Node> ign = null;
        while(true)
        {
            while(index(this.lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new LinkedList<Node>();
                }

                ign.add(this.lexer.next());
            }

            if(ign != null)
            {
                this.ignoredTokens.setIn(this.lexer.peek(), ign);
                ign = null;
            }

            this.last_pos = this.lexer.peek().getPos();
            this.last_line = this.lexer.peek().getLine();
            this.last_token = this.lexer.peek();

            int index = index(this.lexer.peek());
            this.action[0] = Parser.actionTable[state()][0][1];
            this.action[1] = Parser.actionTable[state()][0][2];

            int low = 1;
            int high = Parser.actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < Parser.actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > Parser.actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    this.action[0] = Parser.actionTable[state()][middle][1];
                    this.action[1] = Parser.actionTable[state()][middle][2];
                    break;
                }
            }

            switch(this.action[0])
            {
                case SHIFT:
		    {
		        ArrayList list = new ArrayList();
		        list.add(this.lexer.next());
                        push(this.action[1], list, false);
                    }
		    break;
                case REDUCE:
                    switch(this.action[1])
                    {
                    case 0: /* reduce AAmoduledefinition1ModuleDefinition */
		    {
			ArrayList list = new0();
			push(goTo(0), list, false);
		    }
		    break;
                    case 1: /* reduce AAmoduledefinition2ModuleDefinition */
		    {
			ArrayList list = new1();
			push(goTo(0), list, false);
		    }
		    break;
                    case 2: /* reduce AAmoduledefinition3ModuleDefinition */
		    {
			ArrayList list = new2();
			push(goTo(0), list, false);
		    }
		    break;
                    case 3: /* reduce AAmoduledefinition4ModuleDefinition */
		    {
			ArrayList list = new3();
			push(goTo(0), list, false);
		    }
		    break;
                    case 4: /* reduce ASimpleQualifiedIdentifier */
		    {
			ArrayList list = new4();
			push(goTo(1), list, false);
		    }
		    break;
                    case 5: /* reduce AImportedQualifiedIdentifier */
		    {
			ArrayList list = new5();
			push(goTo(1), list, false);
		    }
		    break;
                    case 6: /* reduce AOneIdentifierList */
		    {
			ArrayList list = new6();
			push(goTo(2), list, false);
		    }
		    break;
                    case 7: /* reduce AManyIdentifierList */
		    {
			ArrayList list = new7();
			push(goTo(2), list, false);
		    }
		    break;
                    case 8: /* reduce AOneTypeArgumentList */
		    {
			ArrayList list = new8();
			push(goTo(3), list, false);
		    }
		    break;
                    case 9: /* reduce AManyTypeArgumentList */
		    {
			ArrayList list = new9();
			push(goTo(3), list, false);
		    }
		    break;
                    case 10: /* reduce ATypeArguments */
		    {
			ArrayList list = new10();
			push(goTo(4), list, false);
		    }
		    break;
                    case 11: /* reduce AImportDeclaration */
		    {
			ArrayList list = new11();
			push(goTo(5), list, false);
		    }
		    break;
                    case 12: /* reduce ATypeDefinition */
		    {
			ArrayList list = new12();
			push(goTo(6), list, false);
		    }
		    break;
                    case 13: /* reduce AClassTypeForm */
		    {
			ArrayList list = new13();
			push(goTo(7), list, false);
		    }
		    break;
                    case 14: /* reduce ASubrangeTypeForm */
		    {
			ArrayList list = new14();
			push(goTo(7), list, false);
		    }
		    break;
                    case 15: /* reduce AEnumTypeForm */
		    {
			ArrayList list = new15();
			push(goTo(7), list, false);
		    }
		    break;
                    case 16: /* reduce AExceptionTypeForm */
		    {
			ArrayList list = new16();
			push(goTo(7), list, false);
		    }
		    break;
                    case 17: /* reduce AFunctypeTypeForm */
		    {
			ArrayList list = new17();
			push(goTo(7), list, false);
		    }
		    break;
                    case 18: /* reduce AClosureTypeForm */
		    {
			ArrayList list = new18();
			push(goTo(7), list, false);
		    }
		    break;
                    case 19: /* reduce AAliasTypeForm */
		    {
			ArrayList list = new19();
			push(goTo(7), list, false);
		    }
		    break;
                    case 20: /* reduce ARenameTypeForm */
		    {
			ArrayList list = new20();
			push(goTo(7), list, false);
		    }
		    break;
                    case 21: /* reduce AAclassform1ClassForm */
		    {
			ArrayList list = new21();
			push(goTo(8), list, false);
		    }
		    break;
                    case 22: /* reduce AAclassform2ClassForm */
		    {
			ArrayList list = new22();
			push(goTo(8), list, false);
		    }
		    break;
                    case 23: /* reduce AAclassform3ClassForm */
		    {
			ArrayList list = new23();
			push(goTo(8), list, false);
		    }
		    break;
                    case 24: /* reduce AAclassform4ClassForm */
		    {
			ArrayList list = new24();
			push(goTo(8), list, false);
		    }
		    break;
                    case 25: /* reduce ASubrangeForm */
		    {
			ArrayList list = new25();
			push(goTo(9), list, false);
		    }
		    break;
                    case 26: /* reduce AAenumform1EnumForm */
		    {
			ArrayList list = new26();
			push(goTo(10), list, false);
		    }
		    break;
                    case 27: /* reduce AAenumform2EnumForm */
		    {
			ArrayList list = new27();
			push(goTo(10), list, false);
		    }
		    break;
                    case 28: /* reduce AAexceptionform1ExceptionForm */
		    {
			ArrayList list = new28();
			push(goTo(11), list, false);
		    }
		    break;
                    case 29: /* reduce AAexceptionform2ExceptionForm */
		    {
			ArrayList list = new29();
			push(goTo(11), list, false);
		    }
		    break;
                    case 30: /* reduce AAfunctypeform1FunctypeForm */
		    {
			ArrayList list = new30();
			push(goTo(12), list, false);
		    }
		    break;
                    case 31: /* reduce AAfunctypeform2FunctypeForm */
		    {
			ArrayList list = new31();
			push(goTo(12), list, false);
		    }
		    break;
                    case 32: /* reduce AAclosureform1ClosureForm */
		    {
			ArrayList list = new32();
			push(goTo(13), list, false);
		    }
		    break;
                    case 33: /* reduce AAclosureform2ClosureForm */
		    {
			ArrayList list = new33();
			push(goTo(13), list, false);
		    }
		    break;
                    case 34: /* reduce AAaliasform1AliasForm */
		    {
			ArrayList list = new34();
			push(goTo(14), list, false);
		    }
		    break;
                    case 35: /* reduce AAaliasform2AliasForm */
		    {
			ArrayList list = new35();
			push(goTo(14), list, false);
		    }
		    break;
                    case 36: /* reduce ANullableAliasClause */
		    {
			ArrayList list = new36();
			push(goTo(15), list, false);
		    }
		    break;
                    case 37: /* reduce AGlobaldefDefinition */
		    {
			ArrayList list = new37();
			push(goTo(16), list, false);
		    }
		    break;
                    case 38: /* reduce ATypedefDefinition */
		    {
			ArrayList list = new38();
			push(goTo(16), list, false);
		    }
		    break;
                    case 39: /* reduce AModuledefDefinition */
		    {
			ArrayList list = new39();
			push(goTo(16), list, false);
		    }
		    break;
                    case 40: /* reduce AFundefDefinition */
		    {
			ArrayList list = new40();
			push(goTo(16), list, false);
		    }
		    break;
                    case 41: /* reduce AAvariabletypeform1VariableTypeForm */
		    {
			ArrayList list = new41();
			push(goTo(17), list, false);
		    }
		    break;
                    case 42: /* reduce AAvariabletypeform2VariableTypeForm */
		    {
			ArrayList list = new42();
			push(goTo(17), list, false);
		    }
		    break;
                    case 43: /* reduce AAvariabletypeform3VariableTypeForm */
		    {
			ArrayList list = new43();
			push(goTo(17), list, false);
		    }
		    break;
                    case 44: /* reduce AAvariabletypeform4VariableTypeForm */
		    {
			ArrayList list = new44();
			push(goTo(17), list, false);
		    }
		    break;
                    case 45: /* reduce ATypedVariableDeclaration */
		    {
			ArrayList list = new45();
			push(goTo(18), list, false);
		    }
		    break;
                    case 46: /* reduce ATypedVariableDefinition */
		    {
			ArrayList list = new46();
			push(goTo(19), list, false);
		    }
		    break;
                    case 47: /* reduce AAglobalvariabledefinition1GlobalVariableDefinition */
		    {
			ArrayList list = new47();
			push(goTo(20), list, false);
		    }
		    break;
                    case 48: /* reduce AAglobalvariabledefinition2GlobalVariableDefinition */
		    {
			ArrayList list = new48();
			push(goTo(20), list, false);
		    }
		    break;
                    case 49: /* reduce AAnamedmemberdeclaration1MemberDeclaration */
		    {
			ArrayList list = new49();
			push(goTo(21), list, false);
		    }
		    break;
                    case 50: /* reduce AAnamedmemberdeclaration2MemberDeclaration */
		    {
			ArrayList list = new50();
			push(goTo(21), list, false);
		    }
		    break;
                    case 51: /* reduce AAindexedmemberdeclaration1MemberDeclaration */
		    {
			ArrayList list = new51();
			push(goTo(21), list, false);
		    }
		    break;
                    case 52: /* reduce AAindexedmemberdeclaration2MemberDeclaration */
		    {
			ArrayList list = new52();
			push(goTo(21), list, false);
		    }
		    break;
                    case 53: /* reduce AConstructorMemberDeclaration */
		    {
			ArrayList list = new53();
			push(goTo(21), list, false);
		    }
		    break;
                    case 54: /* reduce ADestructorMemberDeclaration */
		    {
			ArrayList list = new54();
			push(goTo(21), list, false);
		    }
		    break;
                    case 55: /* reduce AAextensionclause1ExtensionClause */
		    {
			ArrayList list = new55();
			push(goTo(22), list, false);
		    }
		    break;
                    case 56: /* reduce AAextensionclause2ExtensionClause */
		    {
			ArrayList list = new56();
			push(goTo(22), list, false);
		    }
		    break;
                    case 57: /* reduce AAargumentdeclaration1ArgumentDeclaration */
		    {
			ArrayList list = new57();
			push(goTo(23), list, false);
		    }
		    break;
                    case 58: /* reduce AAargumentdeclaration2ArgumentDeclaration */
		    {
			ArrayList list = new58();
			push(goTo(23), list, false);
		    }
		    break;
                    case 59: /* reduce ADynamicGenericArgumentDeclaration */
		    {
			ArrayList list = new59();
			push(goTo(24), list, false);
		    }
		    break;
                    case 60: /* reduce AStaticGenericArgumentDeclaration */
		    {
			ArrayList list = new60();
			push(goTo(24), list, false);
		    }
		    break;
                    case 61: /* reduce AOneArgumentList */
		    {
			ArrayList list = new61();
			push(goTo(25), list, false);
		    }
		    break;
                    case 62: /* reduce AManyArgumentList */
		    {
			ArrayList list = new62();
			push(goTo(25), list, false);
		    }
		    break;
                    case 63: /* reduce AOneGenericArgumentList */
		    {
			ArrayList list = new63();
			push(goTo(26), list, false);
		    }
		    break;
                    case 64: /* reduce AManyGenericArgumentList */
		    {
			ArrayList list = new64();
			push(goTo(26), list, false);
		    }
		    break;
                    case 65: /* reduce ANoneGenericBody */
		    {
			ArrayList list = new65();
			push(goTo(27), list, false);
		    }
		    break;
                    case 66: /* reduce ABodyGenericBody */
		    {
			ArrayList list = new66();
			push(goTo(27), list, false);
		    }
		    break;
                    case 67: /* reduce AGenericFunctionDefinition */
		    {
			ArrayList list = new67();
			push(goTo(28), list, false);
		    }
		    break;
                    case 68: /* reduce AMethodFunctionDefinition */
		    {
			ArrayList list = new68();
			push(goTo(28), list, false);
		    }
		    break;
                    case 69: /* reduce AFunctionFunctionDefinition */
		    {
			ArrayList list = new69();
			push(goTo(28), list, false);
		    }
		    break;
                    case 70: /* reduce AAssignmentexpExpression */
		    {
			ArrayList list = new70();
			push(goTo(29), list, false);
		    }
		    break;
                    case 71: /* reduce ALetexpExpression */
		    {
			ArrayList list = new71();
			push(goTo(29), list, false);
		    }
		    break;
                    case 72: /* reduce ATryexpExpression */
		    {
			ArrayList list = new72();
			push(goTo(29), list, false);
		    }
		    break;
                    case 73: /* reduce AForexpExpression */
		    {
			ArrayList list = new73();
			push(goTo(29), list, false);
		    }
		    break;
                    case 74: /* reduce AWhileexpExpression */
		    {
			ArrayList list = new74();
			push(goTo(29), list, false);
		    }
		    break;
                    case 75: /* reduce ADoexpExpression */
		    {
			ArrayList list = new75();
			push(goTo(29), list, false);
		    }
		    break;
                    case 76: /* reduce AThrowexpExpression */
		    {
			ArrayList list = new76();
			push(goTo(29), list, false);
		    }
		    break;
                    case 77: /* reduce ACondexpExpression */
		    {
			ArrayList list = new77();
			push(goTo(29), list, false);
		    }
		    break;
                    case 78: /* reduce ABlockexpExpression */
		    {
			ArrayList list = new78();
			push(goTo(29), list, false);
		    }
		    break;
                    case 79: /* reduce ACastexpExpression */
		    {
			ArrayList list = new79();
			push(goTo(29), list, false);
		    }
		    break;
                    case 80: /* reduce AOthersExpression */
		    {
			ArrayList list = new80();
			push(goTo(29), list, false);
		    }
		    break;
                    case 81: /* reduce AGreaterExp6 */
		    {
			ArrayList list = new81();
			push(goTo(30), list, false);
		    }
		    break;
                    case 82: /* reduce AGreatereqExp6 */
		    {
			ArrayList list = new82();
			push(goTo(30), list, false);
		    }
		    break;
                    case 83: /* reduce ALessExp6 */
		    {
			ArrayList list = new83();
			push(goTo(30), list, false);
		    }
		    break;
                    case 84: /* reduce ALessereqExp6 */
		    {
			ArrayList list = new84();
			push(goTo(30), list, false);
		    }
		    break;
                    case 85: /* reduce AEqualsExp6 */
		    {
			ArrayList list = new85();
			push(goTo(30), list, false);
		    }
		    break;
                    case 86: /* reduce ADifferentExp6 */
		    {
			ArrayList list = new86();
			push(goTo(30), list, false);
		    }
		    break;
                    case 87: /* reduce AOthersExp6 */
		    {
			ArrayList list = new87();
			push(goTo(30), list, false);
		    }
		    break;
                    case 88: /* reduce AApplyExp5 */
		    {
			ArrayList list = new88();
			push(goTo(31), list, false);
		    }
		    break;
                    case 89: /* reduce AOthersExp5 */
		    {
			ArrayList list = new89();
			push(goTo(31), list, false);
		    }
		    break;
                    case 90: /* reduce AAdditionExp4 */
		    {
			ArrayList list = new90();
			push(goTo(32), list, false);
		    }
		    break;
                    case 91: /* reduce ASubtractionExp4 */
		    {
			ArrayList list = new91();
			push(goTo(32), list, false);
		    }
		    break;
                    case 92: /* reduce AOthersExp4 */
		    {
			ArrayList list = new92();
			push(goTo(32), list, false);
		    }
		    break;
                    case 93: /* reduce AMultiplyExp3 */
		    {
			ArrayList list = new93();
			push(goTo(33), list, false);
		    }
		    break;
                    case 94: /* reduce ADivisionExp3 */
		    {
			ArrayList list = new94();
			push(goTo(33), list, false);
		    }
		    break;
                    case 95: /* reduce AOthersExp3 */
		    {
			ArrayList list = new95();
			push(goTo(33), list, false);
		    }
		    break;
                    case 96: /* reduce AAndExp2 */
		    {
			ArrayList list = new96();
			push(goTo(34), list, false);
		    }
		    break;
                    case 97: /* reduce AOrExp2 */
		    {
			ArrayList list = new97();
			push(goTo(34), list, false);
		    }
		    break;
                    case 98: /* reduce AXorExp2 */
		    {
			ArrayList list = new98();
			push(goTo(34), list, false);
		    }
		    break;
                    case 99: /* reduce AOthersExp2 */
		    {
			ArrayList list = new99();
			push(goTo(34), list, false);
		    }
		    break;
                    case 100: /* reduce AExponentiationExp1 */
		    {
			ArrayList list = new100();
			push(goTo(35), list, false);
		    }
		    break;
                    case 101: /* reduce AOthersExp1 */
		    {
			ArrayList list = new101();
			push(goTo(35), list, false);
		    }
		    break;
                    case 102: /* reduce ANotExp0 */
		    {
			ArrayList list = new102();
			push(goTo(36), list, false);
		    }
		    break;
                    case 103: /* reduce AMinusExp0 */
		    {
			ArrayList list = new103();
			push(goTo(36), list, false);
		    }
		    break;
                    case 104: /* reduce AAtExp0 */
		    {
			ArrayList list = new104();
			push(goTo(36), list, false);
		    }
		    break;
                    case 105: /* reduce ACallExp0 */
		    {
			ArrayList list = new105();
			push(goTo(36), list, false);
		    }
		    break;
                    case 106: /* reduce APrimitiveExp0 */
		    {
			ArrayList list = new106();
			push(goTo(36), list, false);
		    }
		    break;
                    case 107: /* reduce ATupleexpExp0 */
		    {
			ArrayList list = new107();
			push(goTo(36), list, false);
		    }
		    break;
                    case 108: /* reduce ALambdaexpExp0 */
		    {
			ArrayList list = new108();
			push(goTo(36), list, false);
		    }
		    break;
                    case 109: /* reduce AParentheticalExp0 */
		    {
			ArrayList list = new109();
			push(goTo(36), list, false);
		    }
		    break;
                    case 110: /* reduce ALeftExp0 */
		    {
			ArrayList list = new110();
			push(goTo(36), list, false);
		    }
		    break;
                    case 111: /* reduce AAvarargsfunctioncallexpression1FunctionCallExpression */
		    {
			ArrayList list = new111();
			push(goTo(37), list, false);
		    }
		    break;
                    case 112: /* reduce AAvarargsfunctioncallexpression2FunctionCallExpression */
		    {
			ArrayList list = new112();
			push(goTo(37), list, false);
		    }
		    break;
                    case 113: /* reduce AAparentheticalargsfunctioncallexpression1FunctionCallExpression */
		    {
			ArrayList list = new113();
			push(goTo(37), list, false);
		    }
		    break;
                    case 114: /* reduce AAparentheticalargsfunctioncallexpression2FunctionCallExpression */
		    {
			ArrayList list = new114();
			push(goTo(37), list, false);
		    }
		    break;
                    case 115: /* reduce AParentheticalExpression */
		    {
			ArrayList list = new115();
			push(goTo(38), list, false);
		    }
		    break;
                    case 116: /* reduce AVariableSubscript */
		    {
			ArrayList list = new116();
			push(goTo(39), list, false);
		    }
		    break;
                    case 117: /* reduce AVariableLeftExpression */
		    {
			ArrayList list = new117();
			push(goTo(40), list, false);
		    }
		    break;
                    case 118: /* reduce ASubscriptLeftExpression */
		    {
			ArrayList list = new118();
			push(goTo(40), list, false);
		    }
		    break;
                    case 119: /* reduce AParensubLeftExpression */
		    {
			ArrayList list = new119();
			push(goTo(40), list, false);
		    }
		    break;
                    case 120: /* reduce AIntegerPrimitiveExpression */
		    {
			ArrayList list = new120();
			push(goTo(41), list, false);
		    }
		    break;
                    case 121: /* reduce ABooleanPrimitiveExpression */
		    {
			ArrayList list = new121();
			push(goTo(41), list, false);
		    }
		    break;
                    case 122: /* reduce AStringPrimitiveExpression */
		    {
			ArrayList list = new122();
			push(goTo(41), list, false);
		    }
		    break;
                    case 123: /* reduce ANullPrimitiveExpression */
		    {
			ArrayList list = new123();
			push(goTo(41), list, false);
		    }
		    break;
                    case 124: /* reduce AOneExpressionList */
		    {
			ArrayList list = new124();
			push(goTo(42), list, false);
		    }
		    break;
                    case 125: /* reduce AManyExpressionList */
		    {
			ArrayList list = new125();
			push(goTo(42), list, false);
		    }
		    break;
                    case 126: /* reduce ATupleExpression */
		    {
			ArrayList list = new126();
			push(goTo(43), list, false);
		    }
		    break;
                    case 127: /* reduce ALambdaExpression */
		    {
			ArrayList list = new127();
			push(goTo(44), list, false);
		    }
		    break;
                    case 128: /* reduce AApplyExpression */
		    {
			ArrayList list = new128();
			push(goTo(45), list, false);
		    }
		    break;
                    case 129: /* reduce AAssignmentExpression */
		    {
			ArrayList list = new129();
			push(goTo(46), list, false);
		    }
		    break;
                    case 130: /* reduce ALetAssignment */
		    {
			ArrayList list = new130();
			push(goTo(47), list, false);
		    }
		    break;
                    case 131: /* reduce AOneLetAssignmentList */
		    {
			ArrayList list = new131();
			push(goTo(48), list, false);
		    }
		    break;
                    case 132: /* reduce AManyLetAssignmentList */
		    {
			ArrayList list = new132();
			push(goTo(48), list, false);
		    }
		    break;
                    case 133: /* reduce ALetExpression */
		    {
			ArrayList list = new133();
			push(goTo(49), list, false);
		    }
		    break;
                    case 134: /* reduce AExceptExpressionClause */
		    {
			ArrayList list = new134();
			push(goTo(50), list, false);
		    }
		    break;
                    case 135: /* reduce AFinallyExpressionClause */
		    {
			ArrayList list = new135();
			push(goTo(51), list, false);
		    }
		    break;
                    case 136: /* reduce AAtryexpression1TryExpression */
		    {
			ArrayList list = new136();
			push(goTo(52), list, false);
		    }
		    break;
                    case 137: /* reduce AAtryexpression2TryExpression */
		    {
			ArrayList list = new137();
			push(goTo(52), list, false);
		    }
		    break;
                    case 138: /* reduce AForExpression */
		    {
			ArrayList list = new138();
			push(goTo(53), list, false);
		    }
		    break;
                    case 139: /* reduce AWhileExpression */
		    {
			ArrayList list = new139();
			push(goTo(54), list, false);
		    }
		    break;
                    case 140: /* reduce ADoExpression */
		    {
			ArrayList list = new140();
			push(goTo(55), list, false);
		    }
		    break;
                    case 141: /* reduce AThrowExpression */
		    {
			ArrayList list = new141();
			push(goTo(56), list, false);
		    }
		    break;
                    case 142: /* reduce ACaseExpressionClause */
		    {
			ArrayList list = new142();
			push(goTo(57), list, false);
		    }
		    break;
                    case 143: /* reduce AOneCondExpression */
		    {
			ArrayList list = new143();
			push(goTo(58), list, false);
		    }
		    break;
                    case 144: /* reduce AManyCondExpression */
		    {
			ArrayList list = new144();
			push(goTo(58), list, false);
		    }
		    break;
                    case 145: /* reduce ACastExpressionClause */
		    {
			ArrayList list = new145();
			push(goTo(59), list, false);
		    }
		    break;
                    case 146: /* reduce AOneCastExpression */
		    {
			ArrayList list = new146();
			push(goTo(60), list, false);
		    }
		    break;
                    case 147: /* reduce AManyCastExpression */
		    {
			ArrayList list = new147();
			push(goTo(60), list, false);
		    }
		    break;
                    case 148: /* reduce AOneExpressionBlock */
		    {
			ArrayList list = new148();
			push(goTo(61), list, false);
		    }
		    break;
                    case 149: /* reduce AManyExpressionBlock */
		    {
			ArrayList list = new149();
			push(goTo(61), list, false);
		    }
		    break;
                    case 150: /* reduce ABlockExpression */
		    {
			ArrayList list = new150();
			push(goTo(62), list, false);
		    }
		    break;
                    case 151: /* reduce ATerminal$ImportDeclaration */
		    {
			ArrayList list = new151();
			push(goTo(63), list, true);
		    }
		    break;
                    case 152: /* reduce ANonTerminal$ImportDeclaration */
		    {
			ArrayList list = new152();
			push(goTo(63), list, true);
		    }
		    break;
                    case 153: /* reduce ATerminal$Definition */
		    {
			ArrayList list = new153();
			push(goTo(64), list, true);
		    }
		    break;
                    case 154: /* reduce ANonTerminal$Definition */
		    {
			ArrayList list = new154();
			push(goTo(64), list, true);
		    }
		    break;
                    case 155: /* reduce ATerminal$MemberDeclaration */
		    {
			ArrayList list = new155();
			push(goTo(65), list, true);
		    }
		    break;
                    case 156: /* reduce ANonTerminal$MemberDeclaration */
		    {
			ArrayList list = new156();
			push(goTo(65), list, true);
		    }
		    break;
                    case 157: /* reduce ATerminal$ExceptExpressionClause */
		    {
			ArrayList list = new157();
			push(goTo(66), list, true);
		    }
		    break;
                    case 158: /* reduce ANonTerminal$ExceptExpressionClause */
		    {
			ArrayList list = new158();
			push(goTo(66), list, true);
		    }
		    break;
                    case 159: /* reduce ATerminal$CaseExpressionClause */
		    {
			ArrayList list = new159();
			push(goTo(67), list, true);
		    }
		    break;
                    case 160: /* reduce ANonTerminal$CaseExpressionClause */
		    {
			ArrayList list = new160();
			push(goTo(67), list, true);
		    }
		    break;
                    case 161: /* reduce ATerminal$CastExpressionClause */
		    {
			ArrayList list = new161();
			push(goTo(68), list, true);
		    }
		    break;
                    case 162: /* reduce ANonTerminal$CastExpressionClause */
		    {
			ArrayList list = new162();
			push(goTo(68), list, true);
		    }
		    break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) this.lexer.next();
                        PModuleDefinition node1 = (PModuleDefinition) pop().get(0);
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(this.last_token,
                        "[" + this.last_line + "," + this.last_pos + "] " +
                        Parser.errorMessages[Parser.errors[this.action[1]]]);
            }
        }
    }



    @SuppressWarnings("unchecked")
    ArrayList new0() /* reduce AAmoduledefinition1ModuleDefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PModuleDefinition pmoduledefinitionNode1;
        {
            // Block
        TModule tmoduleNode2;
        TUnqualifiedIdentifier tunqualifiedidentifierNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode5 = new LinkedList();
        TEndModule tendmoduleNode6;
        tmoduleNode2 = (TModule)nodeArrayList1.get(0);
        tunqualifiedidentifierNode3 = (TUnqualifiedIdentifier)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        }
        tendmoduleNode6 = (TEndModule)nodeArrayList3.get(0);

        pmoduledefinitionNode1 = new AModuleDefinition(tmoduleNode2, tunqualifiedidentifierNode3, listNode4, listNode5, tendmoduleNode6);
        }
	nodeList.add(pmoduledefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new1() /* reduce AAmoduledefinition2ModuleDefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PModuleDefinition pmoduledefinitionNode1;
        {
            // Block
        TModule tmoduleNode2;
        TUnqualifiedIdentifier tunqualifiedidentifierNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        TEndModule tendmoduleNode7;
        tmoduleNode2 = (TModule)nodeArrayList1.get(0);
        tunqualifiedidentifierNode3 = (TUnqualifiedIdentifier)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null)
	{
	  listNode5.addAll(listNode4);
	}
        }
        {
            // Block
        }
        tendmoduleNode7 = (TEndModule)nodeArrayList4.get(0);

        pmoduledefinitionNode1 = new AModuleDefinition(tmoduleNode2, tunqualifiedidentifierNode3, listNode5, listNode6, tendmoduleNode7);
        }
	nodeList.add(pmoduledefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new2() /* reduce AAmoduledefinition3ModuleDefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PModuleDefinition pmoduledefinitionNode1;
        {
            // Block
        TModule tmoduleNode2;
        TUnqualifiedIdentifier tunqualifiedidentifierNode3;
        LinkedList listNode4 = new LinkedList();
        LinkedList listNode6 = new LinkedList();
        TEndModule tendmoduleNode7;
        tmoduleNode2 = (TModule)nodeArrayList1.get(0);
        tunqualifiedidentifierNode3 = (TUnqualifiedIdentifier)nodeArrayList2.get(0);
        {
            // Block
        }
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList3.get(0);
	if(listNode5 != null)
	{
	  listNode6.addAll(listNode5);
	}
        }
        tendmoduleNode7 = (TEndModule)nodeArrayList4.get(0);

        pmoduledefinitionNode1 = new AModuleDefinition(tmoduleNode2, tunqualifiedidentifierNode3, listNode4, listNode6, tendmoduleNode7);
        }
	nodeList.add(pmoduledefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new3() /* reduce AAmoduledefinition4ModuleDefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PModuleDefinition pmoduledefinitionNode1;
        {
            // Block
        TModule tmoduleNode2;
        TUnqualifiedIdentifier tunqualifiedidentifierNode3;
        LinkedList listNode5 = new LinkedList();
        LinkedList listNode7 = new LinkedList();
        TEndModule tendmoduleNode8;
        tmoduleNode2 = (TModule)nodeArrayList1.get(0);
        tunqualifiedidentifierNode3 = (TUnqualifiedIdentifier)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null)
	{
	  listNode5.addAll(listNode4);
	}
        }
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null)
	{
	  listNode7.addAll(listNode6);
	}
        }
        tendmoduleNode8 = (TEndModule)nodeArrayList5.get(0);

        pmoduledefinitionNode1 = new AModuleDefinition(tmoduleNode2, tunqualifiedidentifierNode3, listNode5, listNode7, tendmoduleNode8);
        }
	nodeList.add(pmoduledefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new4() /* reduce ASimpleQualifiedIdentifier */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PQualifiedIdentifier pqualifiedidentifierNode1;
        {
            // Block
        TUnqualifiedIdentifier tunqualifiedidentifierNode2;
        tunqualifiedidentifierNode2 = (TUnqualifiedIdentifier)nodeArrayList1.get(0);

        pqualifiedidentifierNode1 = new ASimpleQualifiedIdentifier(tunqualifiedidentifierNode2);
        }
	nodeList.add(pqualifiedidentifierNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new5() /* reduce AImportedQualifiedIdentifier */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PQualifiedIdentifier pqualifiedidentifierNode1;
        {
            // Block
        PQualifiedIdentifier pqualifiedidentifierNode2;
        TDot tdotNode3;
        TUnqualifiedIdentifier tunqualifiedidentifierNode4;
        pqualifiedidentifierNode2 = (PQualifiedIdentifier)nodeArrayList1.get(0);
        tdotNode3 = (TDot)nodeArrayList2.get(0);
        tunqualifiedidentifierNode4 = (TUnqualifiedIdentifier)nodeArrayList3.get(0);

        pqualifiedidentifierNode1 = new AImportedQualifiedIdentifier(pqualifiedidentifierNode2, tdotNode3, tunqualifiedidentifierNode4);
        }
	nodeList.add(pqualifiedidentifierNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new6() /* reduce AOneIdentifierList */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PIdentifierList pidentifierlistNode1;
        {
            // Block
        TUnqualifiedIdentifier tunqualifiedidentifierNode2;
        tunqualifiedidentifierNode2 = (TUnqualifiedIdentifier)nodeArrayList1.get(0);

        pidentifierlistNode1 = new AOneIdentifierList(tunqualifiedidentifierNode2);
        }
	nodeList.add(pidentifierlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new7() /* reduce AManyIdentifierList */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PIdentifierList pidentifierlistNode1;
        {
            // Block
        PIdentifierList pidentifierlistNode2;
        TComma tcommaNode3;
        TUnqualifiedIdentifier tunqualifiedidentifierNode4;
        pidentifierlistNode2 = (PIdentifierList)nodeArrayList1.get(0);
        tcommaNode3 = (TComma)nodeArrayList2.get(0);
        tunqualifiedidentifierNode4 = (TUnqualifiedIdentifier)nodeArrayList3.get(0);

        pidentifierlistNode1 = new AManyIdentifierList(pidentifierlistNode2, tcommaNode3, tunqualifiedidentifierNode4);
        }
	nodeList.add(pidentifierlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new8() /* reduce AOneTypeArgumentList */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTypeArgumentList ptypeargumentlistNode1;
        {
            // Block
        TUnqualifiedIdentifier tunqualifiedidentifierNode2;
        tunqualifiedidentifierNode2 = (TUnqualifiedIdentifier)nodeArrayList1.get(0);

        ptypeargumentlistNode1 = new AOneTypeArgumentList(tunqualifiedidentifierNode2);
        }
	nodeList.add(ptypeargumentlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new9() /* reduce AManyTypeArgumentList */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTypeArgumentList ptypeargumentlistNode1;
        {
            // Block
        PTypeArgumentList ptypeargumentlistNode2;
        TComma tcommaNode3;
        TUnqualifiedIdentifier tunqualifiedidentifierNode4;
        ptypeargumentlistNode2 = (PTypeArgumentList)nodeArrayList1.get(0);
        tcommaNode3 = (TComma)nodeArrayList2.get(0);
        tunqualifiedidentifierNode4 = (TUnqualifiedIdentifier)nodeArrayList3.get(0);

        ptypeargumentlistNode1 = new AManyTypeArgumentList(ptypeargumentlistNode2, tcommaNode3, tunqualifiedidentifierNode4);
        }
	nodeList.add(ptypeargumentlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new10() /* reduce ATypeArguments */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTypeArguments ptypeargumentsNode1;
        {
            // Block
        TLabracket tlabracketNode2;
        PTypeArgumentList ptypeargumentlistNode3;
        TRabracket trabracketNode4;
        tlabracketNode2 = (TLabracket)nodeArrayList1.get(0);
        ptypeargumentlistNode3 = (PTypeArgumentList)nodeArrayList2.get(0);
        trabracketNode4 = (TRabracket)nodeArrayList3.get(0);

        ptypeargumentsNode1 = new ATypeArguments(tlabracketNode2, ptypeargumentlistNode3, trabracketNode4);
        }
	nodeList.add(ptypeargumentsNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new11() /* reduce AImportDeclaration */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PImportDeclaration pimportdeclarationNode1;
        {
            // Block
        TImport timportNode2;
        PQualifiedIdentifier pqualifiedidentifierNode3;
        TSemicolon tsemicolonNode4;
        timportNode2 = (TImport)nodeArrayList1.get(0);
        pqualifiedidentifierNode3 = (PQualifiedIdentifier)nodeArrayList2.get(0);
        tsemicolonNode4 = (TSemicolon)nodeArrayList3.get(0);

        pimportdeclarationNode1 = new AImportDeclaration(timportNode2, pqualifiedidentifierNode3, tsemicolonNode4);
        }
	nodeList.add(pimportdeclarationNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new12() /* reduce ATypeDefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTypeDefinition ptypedefinitionNode1;
        {
            // Block
        TType ttypeNode2;
        TUnqualifiedIdentifier tunqualifiedidentifierNode3;
        TEquals tequalsNode4;
        PTypeForm ptypeformNode5;
        ttypeNode2 = (TType)nodeArrayList1.get(0);
        tunqualifiedidentifierNode3 = (TUnqualifiedIdentifier)nodeArrayList2.get(0);
        tequalsNode4 = (TEquals)nodeArrayList3.get(0);
        ptypeformNode5 = (PTypeForm)nodeArrayList4.get(0);

        ptypedefinitionNode1 = new ATypeDefinition(ttypeNode2, tunqualifiedidentifierNode3, tequalsNode4, ptypeformNode5);
        }
	nodeList.add(ptypedefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new13() /* reduce AClassTypeForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTypeForm ptypeformNode1;
        {
            // Block
        PClassForm pclassformNode2;
        pclassformNode2 = (PClassForm)nodeArrayList1.get(0);

        ptypeformNode1 = new AClassTypeForm(pclassformNode2);
        }
	nodeList.add(ptypeformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new14() /* reduce ASubrangeTypeForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTypeForm ptypeformNode1;
        {
            // Block
        PSubrangeForm psubrangeformNode2;
        psubrangeformNode2 = (PSubrangeForm)nodeArrayList1.get(0);

        ptypeformNode1 = new ASubrangeTypeForm(psubrangeformNode2);
        }
	nodeList.add(ptypeformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new15() /* reduce AEnumTypeForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTypeForm ptypeformNode1;
        {
            // Block
        PEnumForm penumformNode2;
        penumformNode2 = (PEnumForm)nodeArrayList1.get(0);

        ptypeformNode1 = new AEnumTypeForm(penumformNode2);
        }
	nodeList.add(ptypeformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new16() /* reduce AExceptionTypeForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTypeForm ptypeformNode1;
        {
            // Block
        PExceptionForm pexceptionformNode2;
        pexceptionformNode2 = (PExceptionForm)nodeArrayList1.get(0);

        ptypeformNode1 = new AExceptionTypeForm(pexceptionformNode2);
        }
	nodeList.add(ptypeformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new17() /* reduce AFunctypeTypeForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTypeForm ptypeformNode1;
        {
            // Block
        PFunctypeForm pfunctypeformNode2;
        pfunctypeformNode2 = (PFunctypeForm)nodeArrayList1.get(0);

        ptypeformNode1 = new AFunctypeTypeForm(pfunctypeformNode2);
        }
	nodeList.add(ptypeformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new18() /* reduce AClosureTypeForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTypeForm ptypeformNode1;
        {
            // Block
        PClosureForm pclosureformNode2;
        pclosureformNode2 = (PClosureForm)nodeArrayList1.get(0);

        ptypeformNode1 = new AClosureTypeForm(pclosureformNode2);
        }
	nodeList.add(ptypeformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new19() /* reduce AAliasTypeForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTypeForm ptypeformNode1;
        {
            // Block
        PAliasForm paliasformNode2;
        paliasformNode2 = (PAliasForm)nodeArrayList1.get(0);

        ptypeformNode1 = new AAliasTypeForm(paliasformNode2);
        }
	nodeList.add(ptypeformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new20() /* reduce ARenameTypeForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTypeForm ptypeformNode1;
        {
            // Block
        PQualifiedIdentifier pqualifiedidentifierNode2;
        pqualifiedidentifierNode2 = (PQualifiedIdentifier)nodeArrayList1.get(0);

        ptypeformNode1 = new ARenameTypeForm(pqualifiedidentifierNode2);
        }
	nodeList.add(ptypeformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new21() /* reduce AAclassform1ClassForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PClassForm pclassformNode1;
        {
            // Block
        TClassKeyword tclasskeywordNode2;
        @SuppressWarnings("unused") Object nullNode3 = null;
        @SuppressWarnings("unused") Object nullNode4 = null;
        TLbracket tlbracketNode5;
        LinkedList listNode7 = new LinkedList();
        TRbracket trbracketNode8;
        tclasskeywordNode2 = (TClassKeyword)nodeArrayList1.get(0);
        tlbracketNode5 = (TLbracket)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList3.get(0);
	if(listNode6 != null)
	{
	  listNode7.addAll(listNode6);
	}
        }
        trbracketNode8 = (TRbracket)nodeArrayList4.get(0);

        pclassformNode1 = new AClassForm(tclasskeywordNode2, null, null, tlbracketNode5, listNode7, trbracketNode8);
        }
	nodeList.add(pclassformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new22() /* reduce AAclassform2ClassForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PClassForm pclassformNode1;
        {
            // Block
        TClassKeyword tclasskeywordNode2;
        PTypeArguments ptypeargumentsNode3;
        @SuppressWarnings("unused") Object nullNode4 = null;
        TLbracket tlbracketNode5;
        LinkedList listNode7 = new LinkedList();
        TRbracket trbracketNode8;
        tclasskeywordNode2 = (TClassKeyword)nodeArrayList1.get(0);
        ptypeargumentsNode3 = (PTypeArguments)nodeArrayList2.get(0);
        tlbracketNode5 = (TLbracket)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null)
	{
	  listNode7.addAll(listNode6);
	}
        }
        trbracketNode8 = (TRbracket)nodeArrayList5.get(0);

        pclassformNode1 = new AClassForm(tclasskeywordNode2, ptypeargumentsNode3, null, tlbracketNode5, listNode7, trbracketNode8);
        }
	nodeList.add(pclassformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new23() /* reduce AAclassform3ClassForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PClassForm pclassformNode1;
        {
            // Block
        TClassKeyword tclasskeywordNode2;
        @SuppressWarnings("unused") Object nullNode3 = null;
        PExtensionClause pextensionclauseNode4;
        TLbracket tlbracketNode5;
        LinkedList listNode7 = new LinkedList();
        TRbracket trbracketNode8;
        tclasskeywordNode2 = (TClassKeyword)nodeArrayList1.get(0);
        pextensionclauseNode4 = (PExtensionClause)nodeArrayList2.get(0);
        tlbracketNode5 = (TLbracket)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList4.get(0);
	if(listNode6 != null)
	{
	  listNode7.addAll(listNode6);
	}
        }
        trbracketNode8 = (TRbracket)nodeArrayList5.get(0);

        pclassformNode1 = new AClassForm(tclasskeywordNode2, null, pextensionclauseNode4, tlbracketNode5, listNode7, trbracketNode8);
        }
	nodeList.add(pclassformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new24() /* reduce AAclassform4ClassForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PClassForm pclassformNode1;
        {
            // Block
        TClassKeyword tclasskeywordNode2;
        PTypeArguments ptypeargumentsNode3;
        PExtensionClause pextensionclauseNode4;
        TLbracket tlbracketNode5;
        LinkedList listNode7 = new LinkedList();
        TRbracket trbracketNode8;
        tclasskeywordNode2 = (TClassKeyword)nodeArrayList1.get(0);
        ptypeargumentsNode3 = (PTypeArguments)nodeArrayList2.get(0);
        pextensionclauseNode4 = (PExtensionClause)nodeArrayList3.get(0);
        tlbracketNode5 = (TLbracket)nodeArrayList4.get(0);
        {
            // Block
        LinkedList listNode6 = new LinkedList();
        listNode6 = (LinkedList)nodeArrayList5.get(0);
	if(listNode6 != null)
	{
	  listNode7.addAll(listNode6);
	}
        }
        trbracketNode8 = (TRbracket)nodeArrayList6.get(0);

        pclassformNode1 = new AClassForm(tclasskeywordNode2, ptypeargumentsNode3, pextensionclauseNode4, tlbracketNode5, listNode7, trbracketNode8);
        }
	nodeList.add(pclassformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new25() /* reduce ASubrangeForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList8 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PSubrangeForm psubrangeformNode1;
        {
            // Block
        TSubrange tsubrangeNode2;
        TLparen tlparenNode3;
        PExpression pexpressionNode4;
        TComma tcommaNode5;
        PExpression pexpressionNode6;
        TRparen trparenNode7;
        PExtensionClause pextensionclauseNode8;
        TSemicolon tsemicolonNode9;
        tsubrangeNode2 = (TSubrange)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        pexpressionNode4 = (PExpression)nodeArrayList3.get(0);
        tcommaNode5 = (TComma)nodeArrayList4.get(0);
        pexpressionNode6 = (PExpression)nodeArrayList5.get(0);
        trparenNode7 = (TRparen)nodeArrayList6.get(0);
        pextensionclauseNode8 = (PExtensionClause)nodeArrayList7.get(0);
        tsemicolonNode9 = (TSemicolon)nodeArrayList8.get(0);

        psubrangeformNode1 = new ASubrangeForm(tsubrangeNode2, tlparenNode3, pexpressionNode4, tcommaNode5, pexpressionNode6, trparenNode7, pextensionclauseNode8, tsemicolonNode9);
        }
	nodeList.add(psubrangeformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new26() /* reduce AAenumform1EnumForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PEnumForm penumformNode1;
        {
            // Block
        TEnum tenumNode2;
        TLparen tlparenNode3;
        PIdentifierList pidentifierlistNode4;
        TRparen trparenNode5;
        @SuppressWarnings("unused") Object nullNode6 = null;
        TSemicolon tsemicolonNode7;
        tenumNode2 = (TEnum)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        pidentifierlistNode4 = (PIdentifierList)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);
        tsemicolonNode7 = (TSemicolon)nodeArrayList5.get(0);

        penumformNode1 = new AEnumForm(tenumNode2, tlparenNode3, pidentifierlistNode4, trparenNode5, null, tsemicolonNode7);
        }
	nodeList.add(penumformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new27() /* reduce AAenumform2EnumForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PEnumForm penumformNode1;
        {
            // Block
        TEnum tenumNode2;
        TLparen tlparenNode3;
        PIdentifierList pidentifierlistNode4;
        TRparen trparenNode5;
        PExtensionClause pextensionclauseNode6;
        TSemicolon tsemicolonNode7;
        tenumNode2 = (TEnum)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        pidentifierlistNode4 = (PIdentifierList)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);
        pextensionclauseNode6 = (PExtensionClause)nodeArrayList5.get(0);
        tsemicolonNode7 = (TSemicolon)nodeArrayList6.get(0);

        penumformNode1 = new AEnumForm(tenumNode2, tlparenNode3, pidentifierlistNode4, trparenNode5, pextensionclauseNode6, tsemicolonNode7);
        }
	nodeList.add(penumformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new28() /* reduce AAexceptionform1ExceptionForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExceptionForm pexceptionformNode1;
        {
            // Block
        TException texceptionNode2;
        TLparen tlparenNode3;
        PIdentifierList pidentifierlistNode4;
        TRparen trparenNode5;
        @SuppressWarnings("unused") Object nullNode6 = null;
        TSemicolon tsemicolonNode7;
        texceptionNode2 = (TException)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        pidentifierlistNode4 = (PIdentifierList)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);
        tsemicolonNode7 = (TSemicolon)nodeArrayList5.get(0);

        pexceptionformNode1 = new AExceptionForm(texceptionNode2, tlparenNode3, pidentifierlistNode4, trparenNode5, null, tsemicolonNode7);
        }
	nodeList.add(pexceptionformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new29() /* reduce AAexceptionform2ExceptionForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExceptionForm pexceptionformNode1;
        {
            // Block
        TException texceptionNode2;
        TLparen tlparenNode3;
        PIdentifierList pidentifierlistNode4;
        TRparen trparenNode5;
        PExtensionClause pextensionclauseNode6;
        TSemicolon tsemicolonNode7;
        texceptionNode2 = (TException)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        pidentifierlistNode4 = (PIdentifierList)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);
        pextensionclauseNode6 = (PExtensionClause)nodeArrayList5.get(0);
        tsemicolonNode7 = (TSemicolon)nodeArrayList6.get(0);

        pexceptionformNode1 = new AExceptionForm(texceptionNode2, tlparenNode3, pidentifierlistNode4, trparenNode5, pextensionclauseNode6, tsemicolonNode7);
        }
	nodeList.add(pexceptionformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new30() /* reduce AAfunctypeform1FunctypeForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctypeForm pfunctypeformNode1;
        {
            // Block
        TFunction tfunctionNode2;
        @SuppressWarnings("unused") Object nullNode3 = null;
        TLparen tlparenNode4;
        PArgumentList pargumentlistNode5;
        TRparen trparenNode6;
        TSemicolon tsemicolonNode7;
        tfunctionNode2 = (TFunction)nodeArrayList1.get(0);
        tlparenNode4 = (TLparen)nodeArrayList2.get(0);
        pargumentlistNode5 = (PArgumentList)nodeArrayList3.get(0);
        trparenNode6 = (TRparen)nodeArrayList4.get(0);
        tsemicolonNode7 = (TSemicolon)nodeArrayList5.get(0);

        pfunctypeformNode1 = new AFunctypeForm(tfunctionNode2, null, tlparenNode4, pargumentlistNode5, trparenNode6, tsemicolonNode7);
        }
	nodeList.add(pfunctypeformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new31() /* reduce AAfunctypeform2FunctypeForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctypeForm pfunctypeformNode1;
        {
            // Block
        TFunction tfunctionNode2;
        PQualifiedIdentifier pqualifiedidentifierNode3;
        TLparen tlparenNode4;
        PArgumentList pargumentlistNode5;
        TRparen trparenNode6;
        TSemicolon tsemicolonNode7;
        tfunctionNode2 = (TFunction)nodeArrayList1.get(0);
        pqualifiedidentifierNode3 = (PQualifiedIdentifier)nodeArrayList2.get(0);
        tlparenNode4 = (TLparen)nodeArrayList3.get(0);
        pargumentlistNode5 = (PArgumentList)nodeArrayList4.get(0);
        trparenNode6 = (TRparen)nodeArrayList5.get(0);
        tsemicolonNode7 = (TSemicolon)nodeArrayList6.get(0);

        pfunctypeformNode1 = new AFunctypeForm(tfunctionNode2, pqualifiedidentifierNode3, tlparenNode4, pargumentlistNode5, trparenNode6, tsemicolonNode7);
        }
	nodeList.add(pfunctypeformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new32() /* reduce AAclosureform1ClosureForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PClosureForm pclosureformNode1;
        {
            // Block
        TClosure tclosureNode2;
        PExtensionClause pextensionclauseNode3;
        TLbracket tlbracketNode4;
        LinkedList listNode5 = new LinkedList();
        TRbracket trbracketNode6;
        tclosureNode2 = (TClosure)nodeArrayList1.get(0);
        pextensionclauseNode3 = (PExtensionClause)nodeArrayList2.get(0);
        tlbracketNode4 = (TLbracket)nodeArrayList3.get(0);
        {
            // Block
        }
        trbracketNode6 = (TRbracket)nodeArrayList4.get(0);

        pclosureformNode1 = new AClosureForm(tclosureNode2, pextensionclauseNode3, tlbracketNode4, listNode5, trbracketNode6);
        }
	nodeList.add(pclosureformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new33() /* reduce AAclosureform2ClosureForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PClosureForm pclosureformNode1;
        {
            // Block
        TClosure tclosureNode2;
        PExtensionClause pextensionclauseNode3;
        TLbracket tlbracketNode4;
        LinkedList listNode6 = new LinkedList();
        TRbracket trbracketNode7;
        tclosureNode2 = (TClosure)nodeArrayList1.get(0);
        pextensionclauseNode3 = (PExtensionClause)nodeArrayList2.get(0);
        tlbracketNode4 = (TLbracket)nodeArrayList3.get(0);
        {
            // Block
        LinkedList listNode5 = new LinkedList();
        listNode5 = (LinkedList)nodeArrayList4.get(0);
	if(listNode5 != null)
	{
	  listNode6.addAll(listNode5);
	}
        }
        trbracketNode7 = (TRbracket)nodeArrayList5.get(0);

        pclosureformNode1 = new AClosureForm(tclosureNode2, pextensionclauseNode3, tlbracketNode4, listNode6, trbracketNode7);
        }
	nodeList.add(pclosureformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new34() /* reduce AAaliasform1AliasForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAliasForm paliasformNode1;
        {
            // Block
        PQualifiedIdentifier pqualifiedidentifierNode2;
        TAliasOperator taliasoperatorNode3;
        @SuppressWarnings("unused") Object nullNode4 = null;
        TSemicolon tsemicolonNode5;
        pqualifiedidentifierNode2 = (PQualifiedIdentifier)nodeArrayList1.get(0);
        taliasoperatorNode3 = (TAliasOperator)nodeArrayList2.get(0);
        tsemicolonNode5 = (TSemicolon)nodeArrayList3.get(0);

        paliasformNode1 = new AAliasForm(pqualifiedidentifierNode2, taliasoperatorNode3, null, tsemicolonNode5);
        }
	nodeList.add(paliasformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new35() /* reduce AAaliasform2AliasForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAliasForm paliasformNode1;
        {
            // Block
        PQualifiedIdentifier pqualifiedidentifierNode2;
        TAliasOperator taliasoperatorNode3;
        PNullableAliasClause pnullablealiasclauseNode4;
        TSemicolon tsemicolonNode5;
        pqualifiedidentifierNode2 = (PQualifiedIdentifier)nodeArrayList1.get(0);
        taliasoperatorNode3 = (TAliasOperator)nodeArrayList2.get(0);
        pnullablealiasclauseNode4 = (PNullableAliasClause)nodeArrayList3.get(0);
        tsemicolonNode5 = (TSemicolon)nodeArrayList4.get(0);

        paliasformNode1 = new AAliasForm(pqualifiedidentifierNode2, taliasoperatorNode3, pnullablealiasclauseNode4, tsemicolonNode5);
        }
	nodeList.add(paliasformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new36() /* reduce ANullableAliasClause */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PNullableAliasClause pnullablealiasclauseNode1;
        {
            // Block
        TOrOperator toroperatorNode2;
        TNullLiteral tnullliteralNode3;
        toroperatorNode2 = (TOrOperator)nodeArrayList1.get(0);
        tnullliteralNode3 = (TNullLiteral)nodeArrayList2.get(0);

        pnullablealiasclauseNode1 = new ANullableAliasClause(toroperatorNode2, tnullliteralNode3);
        }
	nodeList.add(pnullablealiasclauseNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new37() /* reduce AGlobaldefDefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PDefinition pdefinitionNode1;
        {
            // Block
        PGlobalVariableDefinition pglobalvariabledefinitionNode2;
        pglobalvariabledefinitionNode2 = (PGlobalVariableDefinition)nodeArrayList1.get(0);

        pdefinitionNode1 = new AGlobaldefDefinition(pglobalvariabledefinitionNode2);
        }
	nodeList.add(pdefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new38() /* reduce ATypedefDefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PDefinition pdefinitionNode1;
        {
            // Block
        PTypeDefinition ptypedefinitionNode2;
        ptypedefinitionNode2 = (PTypeDefinition)nodeArrayList1.get(0);

        pdefinitionNode1 = new ATypedefDefinition(ptypedefinitionNode2);
        }
	nodeList.add(pdefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new39() /* reduce AModuledefDefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PDefinition pdefinitionNode1;
        {
            // Block
        PModuleDefinition pmoduledefinitionNode2;
        pmoduledefinitionNode2 = (PModuleDefinition)nodeArrayList1.get(0);

        pdefinitionNode1 = new AModuledefDefinition(pmoduledefinitionNode2);
        }
	nodeList.add(pdefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new40() /* reduce AFundefDefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PDefinition pdefinitionNode1;
        {
            // Block
        PFunctionDefinition pfunctiondefinitionNode2;
        pfunctiondefinitionNode2 = (PFunctionDefinition)nodeArrayList1.get(0);

        pdefinitionNode1 = new AFundefDefinition(pfunctiondefinitionNode2);
        }
	nodeList.add(pdefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new41() /* reduce AAvariabletypeform1VariableTypeForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVariableTypeForm pvariabletypeformNode1;
        {
            // Block
        @SuppressWarnings("unused") Object nullNode2 = null;
        PQualifiedIdentifier pqualifiedidentifierNode3;
        @SuppressWarnings("unused") Object nullNode4 = null;
        pqualifiedidentifierNode3 = (PQualifiedIdentifier)nodeArrayList1.get(0);

        pvariabletypeformNode1 = new AVariableTypeForm(null, pqualifiedidentifierNode3, null);
        }
	nodeList.add(pvariabletypeformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new42() /* reduce AAvariabletypeform2VariableTypeForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVariableTypeForm pvariabletypeformNode1;
        {
            // Block
        TAliasOperator taliasoperatorNode2;
        PQualifiedIdentifier pqualifiedidentifierNode3;
        @SuppressWarnings("unused") Object nullNode4 = null;
        taliasoperatorNode2 = (TAliasOperator)nodeArrayList1.get(0);
        pqualifiedidentifierNode3 = (PQualifiedIdentifier)nodeArrayList2.get(0);

        pvariabletypeformNode1 = new AVariableTypeForm(taliasoperatorNode2, pqualifiedidentifierNode3, null);
        }
	nodeList.add(pvariabletypeformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new43() /* reduce AAvariabletypeform3VariableTypeForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVariableTypeForm pvariabletypeformNode1;
        {
            // Block
        @SuppressWarnings("unused") Object nullNode2 = null;
        PQualifiedIdentifier pqualifiedidentifierNode3;
        PTypeArguments ptypeargumentsNode4;
        pqualifiedidentifierNode3 = (PQualifiedIdentifier)nodeArrayList1.get(0);
        ptypeargumentsNode4 = (PTypeArguments)nodeArrayList2.get(0);

        pvariabletypeformNode1 = new AVariableTypeForm(null, pqualifiedidentifierNode3, ptypeargumentsNode4);
        }
	nodeList.add(pvariabletypeformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new44() /* reduce AAvariabletypeform4VariableTypeForm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVariableTypeForm pvariabletypeformNode1;
        {
            // Block
        TAliasOperator taliasoperatorNode2;
        PQualifiedIdentifier pqualifiedidentifierNode3;
        PTypeArguments ptypeargumentsNode4;
        taliasoperatorNode2 = (TAliasOperator)nodeArrayList1.get(0);
        pqualifiedidentifierNode3 = (PQualifiedIdentifier)nodeArrayList2.get(0);
        ptypeargumentsNode4 = (PTypeArguments)nodeArrayList3.get(0);

        pvariabletypeformNode1 = new AVariableTypeForm(taliasoperatorNode2, pqualifiedidentifierNode3, ptypeargumentsNode4);
        }
	nodeList.add(pvariabletypeformNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new45() /* reduce ATypedVariableDeclaration */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTypedVariableDeclaration ptypedvariabledeclarationNode1;
        {
            // Block
        TUnqualifiedIdentifier tunqualifiedidentifierNode2;
        TAliasOperator taliasoperatorNode3;
        PVariableTypeForm pvariabletypeformNode4;
        tunqualifiedidentifierNode2 = (TUnqualifiedIdentifier)nodeArrayList1.get(0);
        taliasoperatorNode3 = (TAliasOperator)nodeArrayList2.get(0);
        pvariabletypeformNode4 = (PVariableTypeForm)nodeArrayList3.get(0);

        ptypedvariabledeclarationNode1 = new ATypedVariableDeclaration(tunqualifiedidentifierNode2, taliasoperatorNode3, pvariabletypeformNode4);
        }
	nodeList.add(ptypedvariabledeclarationNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new46() /* reduce ATypedVariableDefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTypedVariableDefinition ptypedvariabledefinitionNode1;
        {
            // Block
        PTypedVariableDeclaration ptypedvariabledeclarationNode2;
        TAssignmentOperator tassignmentoperatorNode3;
        PExpression pexpressionNode4;
        ptypedvariabledeclarationNode2 = (PTypedVariableDeclaration)nodeArrayList1.get(0);
        tassignmentoperatorNode3 = (TAssignmentOperator)nodeArrayList2.get(0);
        pexpressionNode4 = (PExpression)nodeArrayList3.get(0);

        ptypedvariabledefinitionNode1 = new ATypedVariableDefinition(ptypedvariabledeclarationNode2, tassignmentoperatorNode3, pexpressionNode4);
        }
	nodeList.add(ptypedvariabledefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new47() /* reduce AAglobalvariabledefinition1GlobalVariableDefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PGlobalVariableDefinition pglobalvariabledefinitionNode1;
        {
            // Block
        TDefine tdefineNode2;
        @SuppressWarnings("unused") Object nullNode3 = null;
        PTypedVariableDefinition ptypedvariabledefinitionNode4;
        TSemicolon tsemicolonNode5;
        tdefineNode2 = (TDefine)nodeArrayList1.get(0);
        ptypedvariabledefinitionNode4 = (PTypedVariableDefinition)nodeArrayList2.get(0);
        tsemicolonNode5 = (TSemicolon)nodeArrayList3.get(0);

        pglobalvariabledefinitionNode1 = new AGlobalVariableDefinition(tdefineNode2, null, ptypedvariabledefinitionNode4, tsemicolonNode5);
        }
	nodeList.add(pglobalvariabledefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new48() /* reduce AAglobalvariabledefinition2GlobalVariableDefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PGlobalVariableDefinition pglobalvariabledefinitionNode1;
        {
            // Block
        TDefine tdefineNode2;
        TGlobalVariableModifier tglobalvariablemodifierNode3;
        PTypedVariableDefinition ptypedvariabledefinitionNode4;
        TSemicolon tsemicolonNode5;
        tdefineNode2 = (TDefine)nodeArrayList1.get(0);
        tglobalvariablemodifierNode3 = (TGlobalVariableModifier)nodeArrayList2.get(0);
        ptypedvariabledefinitionNode4 = (PTypedVariableDefinition)nodeArrayList3.get(0);
        tsemicolonNode5 = (TSemicolon)nodeArrayList4.get(0);

        pglobalvariabledefinitionNode1 = new AGlobalVariableDefinition(tdefineNode2, tglobalvariablemodifierNode3, ptypedvariabledefinitionNode4, tsemicolonNode5);
        }
	nodeList.add(pglobalvariabledefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new49() /* reduce AAnamedmemberdeclaration1MemberDeclaration */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMemberDeclaration pmemberdeclarationNode1;
        {
            // Block
        @SuppressWarnings("unused") Object nullNode2 = null;
        PIdentifierList pidentifierlistNode3;
        PVariableTypeForm pvariabletypeformNode4;
        TSemicolon tsemicolonNode5;
        pidentifierlistNode3 = (PIdentifierList)nodeArrayList1.get(0);
        pvariabletypeformNode4 = (PVariableTypeForm)nodeArrayList2.get(0);
        tsemicolonNode5 = (TSemicolon)nodeArrayList3.get(0);

        pmemberdeclarationNode1 = new ANamedMemberDeclaration(null, pidentifierlistNode3, pvariabletypeformNode4, tsemicolonNode5);
        }
	nodeList.add(pmemberdeclarationNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new50() /* reduce AAnamedmemberdeclaration2MemberDeclaration */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMemberDeclaration pmemberdeclarationNode1;
        {
            // Block
        TPublicityModifier tpublicitymodifierNode2;
        PIdentifierList pidentifierlistNode3;
        PVariableTypeForm pvariabletypeformNode4;
        TSemicolon tsemicolonNode5;
        tpublicitymodifierNode2 = (TPublicityModifier)nodeArrayList1.get(0);
        pidentifierlistNode3 = (PIdentifierList)nodeArrayList2.get(0);
        pvariabletypeformNode4 = (PVariableTypeForm)nodeArrayList3.get(0);
        tsemicolonNode5 = (TSemicolon)nodeArrayList4.get(0);

        pmemberdeclarationNode1 = new ANamedMemberDeclaration(tpublicitymodifierNode2, pidentifierlistNode3, pvariabletypeformNode4, tsemicolonNode5);
        }
	nodeList.add(pmemberdeclarationNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new51() /* reduce AAindexedmemberdeclaration1MemberDeclaration */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMemberDeclaration pmemberdeclarationNode1;
        {
            // Block
        @SuppressWarnings("unused") Object nullNode2 = null;
        PVariableTypeForm pvariabletypeformNode3;
        TLsbracket tlsbracketNode4;
        TIntegerConstant tintegerconstantNode5;
        TRsbracket trsbracketNode6;
        TSemicolon tsemicolonNode7;
        pvariabletypeformNode3 = (PVariableTypeForm)nodeArrayList1.get(0);
        tlsbracketNode4 = (TLsbracket)nodeArrayList2.get(0);
        tintegerconstantNode5 = (TIntegerConstant)nodeArrayList3.get(0);
        trsbracketNode6 = (TRsbracket)nodeArrayList4.get(0);
        tsemicolonNode7 = (TSemicolon)nodeArrayList5.get(0);

        pmemberdeclarationNode1 = new AIndexedMemberDeclaration(null, pvariabletypeformNode3, tlsbracketNode4, tintegerconstantNode5, trsbracketNode6, tsemicolonNode7);
        }
	nodeList.add(pmemberdeclarationNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new52() /* reduce AAindexedmemberdeclaration2MemberDeclaration */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMemberDeclaration pmemberdeclarationNode1;
        {
            // Block
        TPublicityModifier tpublicitymodifierNode2;
        PVariableTypeForm pvariabletypeformNode3;
        TLsbracket tlsbracketNode4;
        TIntegerConstant tintegerconstantNode5;
        TRsbracket trsbracketNode6;
        TSemicolon tsemicolonNode7;
        tpublicitymodifierNode2 = (TPublicityModifier)nodeArrayList1.get(0);
        pvariabletypeformNode3 = (PVariableTypeForm)nodeArrayList2.get(0);
        tlsbracketNode4 = (TLsbracket)nodeArrayList3.get(0);
        tintegerconstantNode5 = (TIntegerConstant)nodeArrayList4.get(0);
        trsbracketNode6 = (TRsbracket)nodeArrayList5.get(0);
        tsemicolonNode7 = (TSemicolon)nodeArrayList6.get(0);

        pmemberdeclarationNode1 = new AIndexedMemberDeclaration(tpublicitymodifierNode2, pvariabletypeformNode3, tlsbracketNode4, tintegerconstantNode5, trsbracketNode6, tsemicolonNode7);
        }
	nodeList.add(pmemberdeclarationNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new53() /* reduce AConstructorMemberDeclaration */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMemberDeclaration pmemberdeclarationNode1;
        {
            // Block
        TConstructor tconstructorNode2;
        TUnqualifiedIdentifier tunqualifiedidentifierNode3;
        TLparen tlparenNode4;
        PArgumentList pargumentlistNode5;
        TRparen trparenNode6;
        PExpressionBlock pexpressionblockNode7;
        tconstructorNode2 = (TConstructor)nodeArrayList1.get(0);
        tunqualifiedidentifierNode3 = (TUnqualifiedIdentifier)nodeArrayList2.get(0);
        tlparenNode4 = (TLparen)nodeArrayList3.get(0);
        pargumentlistNode5 = (PArgumentList)nodeArrayList4.get(0);
        trparenNode6 = (TRparen)nodeArrayList5.get(0);
        pexpressionblockNode7 = (PExpressionBlock)nodeArrayList6.get(0);

        pmemberdeclarationNode1 = new AConstructorMemberDeclaration(tconstructorNode2, tunqualifiedidentifierNode3, tlparenNode4, pargumentlistNode5, trparenNode6, pexpressionblockNode7);
        }
	nodeList.add(pmemberdeclarationNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new54() /* reduce ADestructorMemberDeclaration */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMemberDeclaration pmemberdeclarationNode1;
        {
            // Block
        TDestructor tdestructorNode2;
        TUnqualifiedIdentifier tunqualifiedidentifierNode3;
        TLparen tlparenNode4;
        PArgumentList pargumentlistNode5;
        TRparen trparenNode6;
        PExpressionBlock pexpressionblockNode7;
        tdestructorNode2 = (TDestructor)nodeArrayList1.get(0);
        tunqualifiedidentifierNode3 = (TUnqualifiedIdentifier)nodeArrayList2.get(0);
        tlparenNode4 = (TLparen)nodeArrayList3.get(0);
        pargumentlistNode5 = (PArgumentList)nodeArrayList4.get(0);
        trparenNode6 = (TRparen)nodeArrayList5.get(0);
        pexpressionblockNode7 = (PExpressionBlock)nodeArrayList6.get(0);

        pmemberdeclarationNode1 = new ADestructorMemberDeclaration(tdestructorNode2, tunqualifiedidentifierNode3, tlparenNode4, pargumentlistNode5, trparenNode6, pexpressionblockNode7);
        }
	nodeList.add(pmemberdeclarationNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new55() /* reduce AAextensionclause1ExtensionClause */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExtensionClause pextensionclauseNode1;
        {
            // Block
        TExtends textendsNode2;
        PQualifiedIdentifier pqualifiedidentifierNode3;
        @SuppressWarnings("unused") Object nullNode4 = null;
        textendsNode2 = (TExtends)nodeArrayList1.get(0);
        pqualifiedidentifierNode3 = (PQualifiedIdentifier)nodeArrayList2.get(0);

        pextensionclauseNode1 = new AExtensionClause(textendsNode2, pqualifiedidentifierNode3, null);
        }
	nodeList.add(pextensionclauseNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new56() /* reduce AAextensionclause2ExtensionClause */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExtensionClause pextensionclauseNode1;
        {
            // Block
        TExtends textendsNode2;
        PQualifiedIdentifier pqualifiedidentifierNode3;
        PTypeArguments ptypeargumentsNode4;
        textendsNode2 = (TExtends)nodeArrayList1.get(0);
        pqualifiedidentifierNode3 = (PQualifiedIdentifier)nodeArrayList2.get(0);
        ptypeargumentsNode4 = (PTypeArguments)nodeArrayList3.get(0);

        pextensionclauseNode1 = new AExtensionClause(textendsNode2, pqualifiedidentifierNode3, ptypeargumentsNode4);
        }
	nodeList.add(pextensionclauseNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new57() /* reduce AAargumentdeclaration1ArgumentDeclaration */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PArgumentDeclaration pargumentdeclarationNode1;
        {
            // Block
        TUnqualifiedIdentifier tunqualifiedidentifierNode2;
        @SuppressWarnings("unused") Object nullNode3 = null;
        tunqualifiedidentifierNode2 = (TUnqualifiedIdentifier)nodeArrayList1.get(0);

        pargumentdeclarationNode1 = new AArgumentDeclaration(tunqualifiedidentifierNode2, null);
        }
	nodeList.add(pargumentdeclarationNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new58() /* reduce AAargumentdeclaration2ArgumentDeclaration */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PArgumentDeclaration pargumentdeclarationNode1;
        {
            // Block
        TUnqualifiedIdentifier tunqualifiedidentifierNode2;
        PQualifiedIdentifier pqualifiedidentifierNode3;
        tunqualifiedidentifierNode2 = (TUnqualifiedIdentifier)nodeArrayList1.get(0);
        pqualifiedidentifierNode3 = (PQualifiedIdentifier)nodeArrayList2.get(0);

        pargumentdeclarationNode1 = new AArgumentDeclaration(tunqualifiedidentifierNode2, pqualifiedidentifierNode3);
        }
	nodeList.add(pargumentdeclarationNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new59() /* reduce ADynamicGenericArgumentDeclaration */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PGenericArgumentDeclaration pgenericargumentdeclarationNode1;
        {
            // Block
        TGeneric tgenericNode2;
        TUnqualifiedIdentifier tunqualifiedidentifierNode3;
        PQualifiedIdentifier pqualifiedidentifierNode4;
        tgenericNode2 = (TGeneric)nodeArrayList1.get(0);
        tunqualifiedidentifierNode3 = (TUnqualifiedIdentifier)nodeArrayList2.get(0);
        pqualifiedidentifierNode4 = (PQualifiedIdentifier)nodeArrayList3.get(0);

        pgenericargumentdeclarationNode1 = new ADynamicGenericArgumentDeclaration(tgenericNode2, tunqualifiedidentifierNode3, pqualifiedidentifierNode4);
        }
	nodeList.add(pgenericargumentdeclarationNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new60() /* reduce AStaticGenericArgumentDeclaration */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PGenericArgumentDeclaration pgenericargumentdeclarationNode1;
        {
            // Block
        PArgumentDeclaration pargumentdeclarationNode2;
        pargumentdeclarationNode2 = (PArgumentDeclaration)nodeArrayList1.get(0);

        pgenericargumentdeclarationNode1 = new AStaticGenericArgumentDeclaration(pargumentdeclarationNode2);
        }
	nodeList.add(pgenericargumentdeclarationNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new61() /* reduce AOneArgumentList */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PArgumentList pargumentlistNode1;
        {
            // Block
        PArgumentDeclaration pargumentdeclarationNode2;
        pargumentdeclarationNode2 = (PArgumentDeclaration)nodeArrayList1.get(0);

        pargumentlistNode1 = new AOneArgumentList(pargumentdeclarationNode2);
        }
	nodeList.add(pargumentlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new62() /* reduce AManyArgumentList */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PArgumentList pargumentlistNode1;
        {
            // Block
        PArgumentList pargumentlistNode2;
        TComma tcommaNode3;
        PArgumentDeclaration pargumentdeclarationNode4;
        pargumentlistNode2 = (PArgumentList)nodeArrayList1.get(0);
        tcommaNode3 = (TComma)nodeArrayList2.get(0);
        pargumentdeclarationNode4 = (PArgumentDeclaration)nodeArrayList3.get(0);

        pargumentlistNode1 = new AManyArgumentList(pargumentlistNode2, tcommaNode3, pargumentdeclarationNode4);
        }
	nodeList.add(pargumentlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new63() /* reduce AOneGenericArgumentList */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PGenericArgumentList pgenericargumentlistNode1;
        {
            // Block
        PGenericArgumentDeclaration pgenericargumentdeclarationNode2;
        pgenericargumentdeclarationNode2 = (PGenericArgumentDeclaration)nodeArrayList1.get(0);

        pgenericargumentlistNode1 = new AOneGenericArgumentList(pgenericargumentdeclarationNode2);
        }
	nodeList.add(pgenericargumentlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new64() /* reduce AManyGenericArgumentList */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PGenericArgumentList pgenericargumentlistNode1;
        {
            // Block
        PGenericArgumentList pgenericargumentlistNode2;
        TComma tcommaNode3;
        PGenericArgumentDeclaration pgenericargumentdeclarationNode4;
        pgenericargumentlistNode2 = (PGenericArgumentList)nodeArrayList1.get(0);
        tcommaNode3 = (TComma)nodeArrayList2.get(0);
        pgenericargumentdeclarationNode4 = (PGenericArgumentDeclaration)nodeArrayList3.get(0);

        pgenericargumentlistNode1 = new AManyGenericArgumentList(pgenericargumentlistNode2, tcommaNode3, pgenericargumentdeclarationNode4);
        }
	nodeList.add(pgenericargumentlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new65() /* reduce ANoneGenericBody */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PGenericBody pgenericbodyNode1;
        {
            // Block
        TSemicolon tsemicolonNode2;
        tsemicolonNode2 = (TSemicolon)nodeArrayList1.get(0);

        pgenericbodyNode1 = new ANoneGenericBody(tsemicolonNode2);
        }
	nodeList.add(pgenericbodyNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new66() /* reduce ABodyGenericBody */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PGenericBody pgenericbodyNode1;
        {
            // Block
        PBlockExpression pblockexpressionNode2;
        pblockexpressionNode2 = (PBlockExpression)nodeArrayList1.get(0);

        pgenericbodyNode1 = new ABodyGenericBody(pblockexpressionNode2);
        }
	nodeList.add(pgenericbodyNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new67() /* reduce AGenericFunctionDefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctionDefinition pfunctiondefinitionNode1;
        {
            // Block
        TGeneric tgenericNode2;
        PQualifiedIdentifier pqualifiedidentifierNode3;
        TUnqualifiedIdentifier tunqualifiedidentifierNode4;
        TLparen tlparenNode5;
        PGenericArgumentList pgenericargumentlistNode6;
        TRparen trparenNode7;
        PGenericBody pgenericbodyNode8;
        tgenericNode2 = (TGeneric)nodeArrayList1.get(0);
        pqualifiedidentifierNode3 = (PQualifiedIdentifier)nodeArrayList2.get(0);
        tunqualifiedidentifierNode4 = (TUnqualifiedIdentifier)nodeArrayList3.get(0);
        tlparenNode5 = (TLparen)nodeArrayList4.get(0);
        pgenericargumentlistNode6 = (PGenericArgumentList)nodeArrayList5.get(0);
        trparenNode7 = (TRparen)nodeArrayList6.get(0);
        pgenericbodyNode8 = (PGenericBody)nodeArrayList7.get(0);

        pfunctiondefinitionNode1 = new AGenericFunctionDefinition(tgenericNode2, pqualifiedidentifierNode3, tunqualifiedidentifierNode4, tlparenNode5, pgenericargumentlistNode6, trparenNode7, pgenericbodyNode8);
        }
	nodeList.add(pfunctiondefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new68() /* reduce AMethodFunctionDefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctionDefinition pfunctiondefinitionNode1;
        {
            // Block
        TMethod tmethodNode2;
        PQualifiedIdentifier pqualifiedidentifierNode3;
        TLparen tlparenNode4;
        PArgumentList pargumentlistNode5;
        TRparen trparenNode6;
        PBlockExpression pblockexpressionNode7;
        tmethodNode2 = (TMethod)nodeArrayList1.get(0);
        pqualifiedidentifierNode3 = (PQualifiedIdentifier)nodeArrayList2.get(0);
        tlparenNode4 = (TLparen)nodeArrayList3.get(0);
        pargumentlistNode5 = (PArgumentList)nodeArrayList4.get(0);
        trparenNode6 = (TRparen)nodeArrayList5.get(0);
        pblockexpressionNode7 = (PBlockExpression)nodeArrayList6.get(0);

        pfunctiondefinitionNode1 = new AMethodFunctionDefinition(tmethodNode2, pqualifiedidentifierNode3, tlparenNode4, pargumentlistNode5, trparenNode6, pblockexpressionNode7);
        }
	nodeList.add(pfunctiondefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new69() /* reduce AFunctionFunctionDefinition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctionDefinition pfunctiondefinitionNode1;
        {
            // Block
        TFunction tfunctionNode2;
        TUnqualifiedIdentifier tunqualifiedidentifierNode3;
        TLparen tlparenNode4;
        PArgumentList pargumentlistNode5;
        TRparen trparenNode6;
        PBlockExpression pblockexpressionNode7;
        tfunctionNode2 = (TFunction)nodeArrayList1.get(0);
        tunqualifiedidentifierNode3 = (TUnqualifiedIdentifier)nodeArrayList2.get(0);
        tlparenNode4 = (TLparen)nodeArrayList3.get(0);
        pargumentlistNode5 = (PArgumentList)nodeArrayList4.get(0);
        trparenNode6 = (TRparen)nodeArrayList5.get(0);
        pblockexpressionNode7 = (PBlockExpression)nodeArrayList6.get(0);

        pfunctiondefinitionNode1 = new AFunctionFunctionDefinition(tfunctionNode2, tunqualifiedidentifierNode3, tlparenNode4, pargumentlistNode5, trparenNode6, pblockexpressionNode7);
        }
	nodeList.add(pfunctiondefinitionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new70() /* reduce AAssignmentexpExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpression pexpressionNode1;
        {
            // Block
        PAssignmentExpression passignmentexpressionNode2;
        passignmentexpressionNode2 = (PAssignmentExpression)nodeArrayList1.get(0);

        pexpressionNode1 = new AAssignmentexpExpression(passignmentexpressionNode2);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new71() /* reduce ALetexpExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpression pexpressionNode1;
        {
            // Block
        PLetExpression pletexpressionNode2;
        pletexpressionNode2 = (PLetExpression)nodeArrayList1.get(0);

        pexpressionNode1 = new ALetexpExpression(pletexpressionNode2);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new72() /* reduce ATryexpExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpression pexpressionNode1;
        {
            // Block
        PTryExpression ptryexpressionNode2;
        ptryexpressionNode2 = (PTryExpression)nodeArrayList1.get(0);

        pexpressionNode1 = new ATryexpExpression(ptryexpressionNode2);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new73() /* reduce AForexpExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpression pexpressionNode1;
        {
            // Block
        PForExpression pforexpressionNode2;
        pforexpressionNode2 = (PForExpression)nodeArrayList1.get(0);

        pexpressionNode1 = new AForexpExpression(pforexpressionNode2);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new74() /* reduce AWhileexpExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpression pexpressionNode1;
        {
            // Block
        PWhileExpression pwhileexpressionNode2;
        pwhileexpressionNode2 = (PWhileExpression)nodeArrayList1.get(0);

        pexpressionNode1 = new AWhileexpExpression(pwhileexpressionNode2);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new75() /* reduce ADoexpExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpression pexpressionNode1;
        {
            // Block
        PDoExpression pdoexpressionNode2;
        pdoexpressionNode2 = (PDoExpression)nodeArrayList1.get(0);

        pexpressionNode1 = new ADoexpExpression(pdoexpressionNode2);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new76() /* reduce AThrowexpExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpression pexpressionNode1;
        {
            // Block
        PThrowExpression pthrowexpressionNode2;
        pthrowexpressionNode2 = (PThrowExpression)nodeArrayList1.get(0);

        pexpressionNode1 = new AThrowexpExpression(pthrowexpressionNode2);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new77() /* reduce ACondexpExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpression pexpressionNode1;
        {
            // Block
        PCondExpression pcondexpressionNode2;
        pcondexpressionNode2 = (PCondExpression)nodeArrayList1.get(0);

        pexpressionNode1 = new ACondexpExpression(pcondexpressionNode2);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new78() /* reduce ABlockexpExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpression pexpressionNode1;
        {
            // Block
        PBlockExpression pblockexpressionNode2;
        pblockexpressionNode2 = (PBlockExpression)nodeArrayList1.get(0);

        pexpressionNode1 = new ABlockexpExpression(pblockexpressionNode2);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new79() /* reduce ACastexpExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpression pexpressionNode1;
        {
            // Block
        PCastExpression pcastexpressionNode2;
        pcastexpressionNode2 = (PCastExpression)nodeArrayList1.get(0);

        pexpressionNode1 = new ACastexpExpression(pcastexpressionNode2);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new80() /* reduce AOthersExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpression pexpressionNode1;
        {
            // Block
        PExp6 pexp6Node2;
        pexp6Node2 = (PExp6)nodeArrayList1.get(0);

        pexpressionNode1 = new AOthersExpression(pexp6Node2);
        }
	nodeList.add(pexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new81() /* reduce AGreaterExp6 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp6 pexp6Node1;
        {
            // Block
        PExp5 pexp5Node2;
        TRabracket trabracketNode3;
        PExp5 pexp5Node4;
        pexp5Node2 = (PExp5)nodeArrayList1.get(0);
        trabracketNode3 = (TRabracket)nodeArrayList2.get(0);
        pexp5Node4 = (PExp5)nodeArrayList3.get(0);

        pexp6Node1 = new AGreaterExp6(pexp5Node2, trabracketNode3, pexp5Node4);
        }
	nodeList.add(pexp6Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new82() /* reduce AGreatereqExp6 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp6 pexp6Node1;
        {
            // Block
        PExp5 pexp5Node2;
        TGreatereq tgreatereqNode3;
        PExp5 pexp5Node4;
        pexp5Node2 = (PExp5)nodeArrayList1.get(0);
        tgreatereqNode3 = (TGreatereq)nodeArrayList2.get(0);
        pexp5Node4 = (PExp5)nodeArrayList3.get(0);

        pexp6Node1 = new AGreatereqExp6(pexp5Node2, tgreatereqNode3, pexp5Node4);
        }
	nodeList.add(pexp6Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new83() /* reduce ALessExp6 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp6 pexp6Node1;
        {
            // Block
        PExp5 pexp5Node2;
        TLabracket tlabracketNode3;
        PExp5 pexp5Node4;
        pexp5Node2 = (PExp5)nodeArrayList1.get(0);
        tlabracketNode3 = (TLabracket)nodeArrayList2.get(0);
        pexp5Node4 = (PExp5)nodeArrayList3.get(0);

        pexp6Node1 = new ALessExp6(pexp5Node2, tlabracketNode3, pexp5Node4);
        }
	nodeList.add(pexp6Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new84() /* reduce ALessereqExp6 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp6 pexp6Node1;
        {
            // Block
        PExp5 pexp5Node2;
        TLessereq tlessereqNode3;
        PExp5 pexp5Node4;
        pexp5Node2 = (PExp5)nodeArrayList1.get(0);
        tlessereqNode3 = (TLessereq)nodeArrayList2.get(0);
        pexp5Node4 = (PExp5)nodeArrayList3.get(0);

        pexp6Node1 = new ALessereqExp6(pexp5Node2, tlessereqNode3, pexp5Node4);
        }
	nodeList.add(pexp6Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new85() /* reduce AEqualsExp6 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp6 pexp6Node1;
        {
            // Block
        PExp5 pexp5Node2;
        TEquals tequalsNode3;
        PExp5 pexp5Node4;
        pexp5Node2 = (PExp5)nodeArrayList1.get(0);
        tequalsNode3 = (TEquals)nodeArrayList2.get(0);
        pexp5Node4 = (PExp5)nodeArrayList3.get(0);

        pexp6Node1 = new AEqualsExp6(pexp5Node2, tequalsNode3, pexp5Node4);
        }
	nodeList.add(pexp6Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new86() /* reduce ADifferentExp6 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp6 pexp6Node1;
        {
            // Block
        PExp5 pexp5Node2;
        TDifferent tdifferentNode3;
        PExp5 pexp5Node4;
        pexp5Node2 = (PExp5)nodeArrayList1.get(0);
        tdifferentNode3 = (TDifferent)nodeArrayList2.get(0);
        pexp5Node4 = (PExp5)nodeArrayList3.get(0);

        pexp6Node1 = new ADifferentExp6(pexp5Node2, tdifferentNode3, pexp5Node4);
        }
	nodeList.add(pexp6Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new87() /* reduce AOthersExp6 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp6 pexp6Node1;
        {
            // Block
        PExp5 pexp5Node2;
        pexp5Node2 = (PExp5)nodeArrayList1.get(0);

        pexp6Node1 = new AOthersExp6(pexp5Node2);
        }
	nodeList.add(pexp6Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new88() /* reduce AApplyExp5 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp5 pexp5Node1;
        {
            // Block
        PExp5 pexp5Node2;
        TApplyOperator tapplyoperatorNode3;
        PExp4 pexp4Node4;
        pexp5Node2 = (PExp5)nodeArrayList1.get(0);
        tapplyoperatorNode3 = (TApplyOperator)nodeArrayList2.get(0);
        pexp4Node4 = (PExp4)nodeArrayList3.get(0);

        pexp5Node1 = new AApplyExp5(pexp5Node2, tapplyoperatorNode3, pexp4Node4);
        }
	nodeList.add(pexp5Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new89() /* reduce AOthersExp5 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp5 pexp5Node1;
        {
            // Block
        PExp4 pexp4Node2;
        pexp4Node2 = (PExp4)nodeArrayList1.get(0);

        pexp5Node1 = new AOthersExp5(pexp4Node2);
        }
	nodeList.add(pexp5Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new90() /* reduce AAdditionExp4 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp4 pexp4Node1;
        {
            // Block
        PExp4 pexp4Node2;
        TAdditionOperator tadditionoperatorNode3;
        PExp3 pexp3Node4;
        pexp4Node2 = (PExp4)nodeArrayList1.get(0);
        tadditionoperatorNode3 = (TAdditionOperator)nodeArrayList2.get(0);
        pexp3Node4 = (PExp3)nodeArrayList3.get(0);

        pexp4Node1 = new AAdditionExp4(pexp4Node2, tadditionoperatorNode3, pexp3Node4);
        }
	nodeList.add(pexp4Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new91() /* reduce ASubtractionExp4 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp4 pexp4Node1;
        {
            // Block
        PExp4 pexp4Node2;
        TSubtractionOperator tsubtractionoperatorNode3;
        PExp3 pexp3Node4;
        pexp4Node2 = (PExp4)nodeArrayList1.get(0);
        tsubtractionoperatorNode3 = (TSubtractionOperator)nodeArrayList2.get(0);
        pexp3Node4 = (PExp3)nodeArrayList3.get(0);

        pexp4Node1 = new ASubtractionExp4(pexp4Node2, tsubtractionoperatorNode3, pexp3Node4);
        }
	nodeList.add(pexp4Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new92() /* reduce AOthersExp4 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp4 pexp4Node1;
        {
            // Block
        PExp3 pexp3Node2;
        pexp3Node2 = (PExp3)nodeArrayList1.get(0);

        pexp4Node1 = new AOthersExp4(pexp3Node2);
        }
	nodeList.add(pexp4Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new93() /* reduce AMultiplyExp3 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp3 pexp3Node1;
        {
            // Block
        PExp3 pexp3Node2;
        TMultiplicationOperator tmultiplicationoperatorNode3;
        PExp2 pexp2Node4;
        pexp3Node2 = (PExp3)nodeArrayList1.get(0);
        tmultiplicationoperatorNode3 = (TMultiplicationOperator)nodeArrayList2.get(0);
        pexp2Node4 = (PExp2)nodeArrayList3.get(0);

        pexp3Node1 = new AMultiplyExp3(pexp3Node2, tmultiplicationoperatorNode3, pexp2Node4);
        }
	nodeList.add(pexp3Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new94() /* reduce ADivisionExp3 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp3 pexp3Node1;
        {
            // Block
        PExp3 pexp3Node2;
        TDivisionOperator tdivisionoperatorNode3;
        PExp2 pexp2Node4;
        pexp3Node2 = (PExp3)nodeArrayList1.get(0);
        tdivisionoperatorNode3 = (TDivisionOperator)nodeArrayList2.get(0);
        pexp2Node4 = (PExp2)nodeArrayList3.get(0);

        pexp3Node1 = new ADivisionExp3(pexp3Node2, tdivisionoperatorNode3, pexp2Node4);
        }
	nodeList.add(pexp3Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new95() /* reduce AOthersExp3 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp3 pexp3Node1;
        {
            // Block
        PExp2 pexp2Node2;
        pexp2Node2 = (PExp2)nodeArrayList1.get(0);

        pexp3Node1 = new AOthersExp3(pexp2Node2);
        }
	nodeList.add(pexp3Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new96() /* reduce AAndExp2 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp2 pexp2Node1;
        {
            // Block
        PExp2 pexp2Node2;
        TAndOperator tandoperatorNode3;
        PExp1 pexp1Node4;
        pexp2Node2 = (PExp2)nodeArrayList1.get(0);
        tandoperatorNode3 = (TAndOperator)nodeArrayList2.get(0);
        pexp1Node4 = (PExp1)nodeArrayList3.get(0);

        pexp2Node1 = new AAndExp2(pexp2Node2, tandoperatorNode3, pexp1Node4);
        }
	nodeList.add(pexp2Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new97() /* reduce AOrExp2 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp2 pexp2Node1;
        {
            // Block
        PExp2 pexp2Node2;
        TOrOperator toroperatorNode3;
        PExp1 pexp1Node4;
        pexp2Node2 = (PExp2)nodeArrayList1.get(0);
        toroperatorNode3 = (TOrOperator)nodeArrayList2.get(0);
        pexp1Node4 = (PExp1)nodeArrayList3.get(0);

        pexp2Node1 = new AOrExp2(pexp2Node2, toroperatorNode3, pexp1Node4);
        }
	nodeList.add(pexp2Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new98() /* reduce AXorExp2 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp2 pexp2Node1;
        {
            // Block
        PExp2 pexp2Node2;
        TXorOperator txoroperatorNode3;
        PExp1 pexp1Node4;
        pexp2Node2 = (PExp2)nodeArrayList1.get(0);
        txoroperatorNode3 = (TXorOperator)nodeArrayList2.get(0);
        pexp1Node4 = (PExp1)nodeArrayList3.get(0);

        pexp2Node1 = new AXorExp2(pexp2Node2, txoroperatorNode3, pexp1Node4);
        }
	nodeList.add(pexp2Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new99() /* reduce AOthersExp2 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp2 pexp2Node1;
        {
            // Block
        PExp1 pexp1Node2;
        pexp1Node2 = (PExp1)nodeArrayList1.get(0);

        pexp2Node1 = new AOthersExp2(pexp1Node2);
        }
	nodeList.add(pexp2Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new100() /* reduce AExponentiationExp1 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp1 pexp1Node1;
        {
            // Block
        PExp1 pexp1Node2;
        TExponentiationOperator texponentiationoperatorNode3;
        PExp0 pexp0Node4;
        pexp1Node2 = (PExp1)nodeArrayList1.get(0);
        texponentiationoperatorNode3 = (TExponentiationOperator)nodeArrayList2.get(0);
        pexp0Node4 = (PExp0)nodeArrayList3.get(0);

        pexp1Node1 = new AExponentiationExp1(pexp1Node2, texponentiationoperatorNode3, pexp0Node4);
        }
	nodeList.add(pexp1Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new101() /* reduce AOthersExp1 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp1 pexp1Node1;
        {
            // Block
        PExp0 pexp0Node2;
        pexp0Node2 = (PExp0)nodeArrayList1.get(0);

        pexp1Node1 = new AOthersExp1(pexp0Node2);
        }
	nodeList.add(pexp1Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new102() /* reduce ANotExp0 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp0 pexp0Node1;
        {
            // Block
        TNotOperator tnotoperatorNode2;
        PExp0 pexp0Node3;
        tnotoperatorNode2 = (TNotOperator)nodeArrayList1.get(0);
        pexp0Node3 = (PExp0)nodeArrayList2.get(0);

        pexp0Node1 = new ANotExp0(tnotoperatorNode2, pexp0Node3);
        }
	nodeList.add(pexp0Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new103() /* reduce AMinusExp0 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp0 pexp0Node1;
        {
            // Block
        TMinusOperator tminusoperatorNode2;
        PExp0 pexp0Node3;
        tminusoperatorNode2 = (TMinusOperator)nodeArrayList1.get(0);
        pexp0Node3 = (PExp0)nodeArrayList2.get(0);

        pexp0Node1 = new AMinusExp0(tminusoperatorNode2, pexp0Node3);
        }
	nodeList.add(pexp0Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new104() /* reduce AAtExp0 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp0 pexp0Node1;
        {
            // Block
        TAtOperator tatoperatorNode2;
        PLeftExpression pleftexpressionNode3;
        tatoperatorNode2 = (TAtOperator)nodeArrayList1.get(0);
        pleftexpressionNode3 = (PLeftExpression)nodeArrayList2.get(0);

        pexp0Node1 = new AAtExp0(tatoperatorNode2, pleftexpressionNode3);
        }
	nodeList.add(pexp0Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new105() /* reduce ACallExp0 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp0 pexp0Node1;
        {
            // Block
        PFunctionCallExpression pfunctioncallexpressionNode2;
        pfunctioncallexpressionNode2 = (PFunctionCallExpression)nodeArrayList1.get(0);

        pexp0Node1 = new ACallExp0(pfunctioncallexpressionNode2);
        }
	nodeList.add(pexp0Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new106() /* reduce APrimitiveExp0 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp0 pexp0Node1;
        {
            // Block
        PPrimitiveExpression pprimitiveexpressionNode2;
        pprimitiveexpressionNode2 = (PPrimitiveExpression)nodeArrayList1.get(0);

        pexp0Node1 = new APrimitiveExp0(pprimitiveexpressionNode2);
        }
	nodeList.add(pexp0Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new107() /* reduce ATupleexpExp0 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp0 pexp0Node1;
        {
            // Block
        PTupleExpression ptupleexpressionNode2;
        ptupleexpressionNode2 = (PTupleExpression)nodeArrayList1.get(0);

        pexp0Node1 = new ATupleexpExp0(ptupleexpressionNode2);
        }
	nodeList.add(pexp0Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new108() /* reduce ALambdaexpExp0 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp0 pexp0Node1;
        {
            // Block
        PLambdaExpression plambdaexpressionNode2;
        plambdaexpressionNode2 = (PLambdaExpression)nodeArrayList1.get(0);

        pexp0Node1 = new ALambdaexpExp0(plambdaexpressionNode2);
        }
	nodeList.add(pexp0Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new109() /* reduce AParentheticalExp0 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp0 pexp0Node1;
        {
            // Block
        PParentheticalExpression pparentheticalexpressionNode2;
        pparentheticalexpressionNode2 = (PParentheticalExpression)nodeArrayList1.get(0);

        pexp0Node1 = new AParentheticalExp0(pparentheticalexpressionNode2);
        }
	nodeList.add(pexp0Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new110() /* reduce ALeftExp0 */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExp0 pexp0Node1;
        {
            // Block
        PLeftExpression pleftexpressionNode2;
        pleftexpressionNode2 = (PLeftExpression)nodeArrayList1.get(0);

        pexp0Node1 = new ALeftExp0(pleftexpressionNode2);
        }
	nodeList.add(pexp0Node1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new111() /* reduce AAvarargsfunctioncallexpression1FunctionCallExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctionCallExpression pfunctioncallexpressionNode1;
        {
            // Block
        PQualifiedIdentifier pqualifiedidentifierNode2;
        TLparen tlparenNode3;
        @SuppressWarnings("unused") Object nullNode4 = null;
        TRparen trparenNode5;
        pqualifiedidentifierNode2 = (PQualifiedIdentifier)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        trparenNode5 = (TRparen)nodeArrayList3.get(0);

        pfunctioncallexpressionNode1 = new AVarargsFunctionCallExpression(pqualifiedidentifierNode2, tlparenNode3, null, trparenNode5);
        }
	nodeList.add(pfunctioncallexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new112() /* reduce AAvarargsfunctioncallexpression2FunctionCallExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctionCallExpression pfunctioncallexpressionNode1;
        {
            // Block
        PQualifiedIdentifier pqualifiedidentifierNode2;
        TLparen tlparenNode3;
        PExpressionList pexpressionlistNode4;
        TRparen trparenNode5;
        pqualifiedidentifierNode2 = (PQualifiedIdentifier)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        pexpressionlistNode4 = (PExpressionList)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);

        pfunctioncallexpressionNode1 = new AVarargsFunctionCallExpression(pqualifiedidentifierNode2, tlparenNode3, pexpressionlistNode4, trparenNode5);
        }
	nodeList.add(pfunctioncallexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new113() /* reduce AAparentheticalargsfunctioncallexpression1FunctionCallExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctionCallExpression pfunctioncallexpressionNode1;
        {
            // Block
        PParentheticalExpression pparentheticalexpressionNode2;
        TLparen tlparenNode3;
        @SuppressWarnings("unused") Object nullNode4 = null;
        TRparen trparenNode5;
        pparentheticalexpressionNode2 = (PParentheticalExpression)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        trparenNode5 = (TRparen)nodeArrayList3.get(0);

        pfunctioncallexpressionNode1 = new AParentheticalargsFunctionCallExpression(pparentheticalexpressionNode2, tlparenNode3, null, trparenNode5);
        }
	nodeList.add(pfunctioncallexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new114() /* reduce AAparentheticalargsfunctioncallexpression2FunctionCallExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFunctionCallExpression pfunctioncallexpressionNode1;
        {
            // Block
        PParentheticalExpression pparentheticalexpressionNode2;
        TLparen tlparenNode3;
        PExpressionList pexpressionlistNode4;
        TRparen trparenNode5;
        pparentheticalexpressionNode2 = (PParentheticalExpression)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        pexpressionlistNode4 = (PExpressionList)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);

        pfunctioncallexpressionNode1 = new AParentheticalargsFunctionCallExpression(pparentheticalexpressionNode2, tlparenNode3, pexpressionlistNode4, trparenNode5);
        }
	nodeList.add(pfunctioncallexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new115() /* reduce AParentheticalExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PParentheticalExpression pparentheticalexpressionNode1;
        {
            // Block
        TLparen tlparenNode2;
        PExpression pexpressionNode3;
        TRparen trparenNode4;
        tlparenNode2 = (TLparen)nodeArrayList1.get(0);
        pexpressionNode3 = (PExpression)nodeArrayList2.get(0);
        trparenNode4 = (TRparen)nodeArrayList3.get(0);

        pparentheticalexpressionNode1 = new AParentheticalExpression(tlparenNode2, pexpressionNode3, trparenNode4);
        }
	nodeList.add(pparentheticalexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new116() /* reduce AVariableSubscript */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVariableSubscript pvariablesubscriptNode1;
        {
            // Block
        TLsbracket tlsbracketNode2;
        PExpression pexpressionNode3;
        TRsbracket trsbracketNode4;
        tlsbracketNode2 = (TLsbracket)nodeArrayList1.get(0);
        pexpressionNode3 = (PExpression)nodeArrayList2.get(0);
        trsbracketNode4 = (TRsbracket)nodeArrayList3.get(0);

        pvariablesubscriptNode1 = new AVariableSubscript(tlsbracketNode2, pexpressionNode3, trsbracketNode4);
        }
	nodeList.add(pvariablesubscriptNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new117() /* reduce AVariableLeftExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PLeftExpression pleftexpressionNode1;
        {
            // Block
        PQualifiedIdentifier pqualifiedidentifierNode2;
        pqualifiedidentifierNode2 = (PQualifiedIdentifier)nodeArrayList1.get(0);

        pleftexpressionNode1 = new AVariableLeftExpression(pqualifiedidentifierNode2);
        }
	nodeList.add(pleftexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new118() /* reduce ASubscriptLeftExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PLeftExpression pleftexpressionNode1;
        {
            // Block
        PLeftExpression pleftexpressionNode2;
        PVariableSubscript pvariablesubscriptNode3;
        pleftexpressionNode2 = (PLeftExpression)nodeArrayList1.get(0);
        pvariablesubscriptNode3 = (PVariableSubscript)nodeArrayList2.get(0);

        pleftexpressionNode1 = new ASubscriptLeftExpression(pleftexpressionNode2, pvariablesubscriptNode3);
        }
	nodeList.add(pleftexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new119() /* reduce AParensubLeftExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PLeftExpression pleftexpressionNode1;
        {
            // Block
        PParentheticalExpression pparentheticalexpressionNode2;
        PVariableSubscript pvariablesubscriptNode3;
        pparentheticalexpressionNode2 = (PParentheticalExpression)nodeArrayList1.get(0);
        pvariablesubscriptNode3 = (PVariableSubscript)nodeArrayList2.get(0);

        pleftexpressionNode1 = new AParensubLeftExpression(pparentheticalexpressionNode2, pvariablesubscriptNode3);
        }
	nodeList.add(pleftexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new120() /* reduce AIntegerPrimitiveExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPrimitiveExpression pprimitiveexpressionNode1;
        {
            // Block
        TIntegerConstant tintegerconstantNode2;
        tintegerconstantNode2 = (TIntegerConstant)nodeArrayList1.get(0);

        pprimitiveexpressionNode1 = new AIntegerPrimitiveExpression(tintegerconstantNode2);
        }
	nodeList.add(pprimitiveexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new121() /* reduce ABooleanPrimitiveExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPrimitiveExpression pprimitiveexpressionNode1;
        {
            // Block
        TBooleanConstant tbooleanconstantNode2;
        tbooleanconstantNode2 = (TBooleanConstant)nodeArrayList1.get(0);

        pprimitiveexpressionNode1 = new ABooleanPrimitiveExpression(tbooleanconstantNode2);
        }
	nodeList.add(pprimitiveexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new122() /* reduce AStringPrimitiveExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPrimitiveExpression pprimitiveexpressionNode1;
        {
            // Block
        TStringConstant tstringconstantNode2;
        tstringconstantNode2 = (TStringConstant)nodeArrayList1.get(0);

        pprimitiveexpressionNode1 = new AStringPrimitiveExpression(tstringconstantNode2);
        }
	nodeList.add(pprimitiveexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new123() /* reduce ANullPrimitiveExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPrimitiveExpression pprimitiveexpressionNode1;
        {
            // Block
        TNullLiteral tnullliteralNode2;
        tnullliteralNode2 = (TNullLiteral)nodeArrayList1.get(0);

        pprimitiveexpressionNode1 = new ANullPrimitiveExpression(tnullliteralNode2);
        }
	nodeList.add(pprimitiveexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new124() /* reduce AOneExpressionList */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpressionList pexpressionlistNode1;
        {
            // Block
        PExpression pexpressionNode2;
        pexpressionNode2 = (PExpression)nodeArrayList1.get(0);

        pexpressionlistNode1 = new AOneExpressionList(pexpressionNode2);
        }
	nodeList.add(pexpressionlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new125() /* reduce AManyExpressionList */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpressionList pexpressionlistNode1;
        {
            // Block
        PExpressionList pexpressionlistNode2;
        TComma tcommaNode3;
        PExpression pexpressionNode4;
        pexpressionlistNode2 = (PExpressionList)nodeArrayList1.get(0);
        tcommaNode3 = (TComma)nodeArrayList2.get(0);
        pexpressionNode4 = (PExpression)nodeArrayList3.get(0);

        pexpressionlistNode1 = new AManyExpressionList(pexpressionlistNode2, tcommaNode3, pexpressionNode4);
        }
	nodeList.add(pexpressionlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new126() /* reduce ATupleExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTupleExpression ptupleexpressionNode1;
        {
            // Block
        TLsbracket tlsbracketNode2;
        PExpressionList pexpressionlistNode3;
        TRsbracket trsbracketNode4;
        tlsbracketNode2 = (TLsbracket)nodeArrayList1.get(0);
        pexpressionlistNode3 = (PExpressionList)nodeArrayList2.get(0);
        trsbracketNode4 = (TRsbracket)nodeArrayList3.get(0);

        ptupleexpressionNode1 = new ATupleExpression(tlsbracketNode2, pexpressionlistNode3, trsbracketNode4);
        }
	nodeList.add(ptupleexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new127() /* reduce ALambdaExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PLambdaExpression plambdaexpressionNode1;
        {
            // Block
        TLambda tlambdaNode2;
        TLparen tlparenNode3;
        PArgumentList pargumentlistNode4;
        TRparen trparenNode5;
        PBlockExpression pblockexpressionNode6;
        tlambdaNode2 = (TLambda)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        pargumentlistNode4 = (PArgumentList)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);
        pblockexpressionNode6 = (PBlockExpression)nodeArrayList5.get(0);

        plambdaexpressionNode1 = new ALambdaExpression(tlambdaNode2, tlparenNode3, pargumentlistNode4, trparenNode5, pblockexpressionNode6);
        }
	nodeList.add(plambdaexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new128() /* reduce AApplyExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PApplyExpression papplyexpressionNode1;
        {
            // Block
        PExpression pexpressionNode2;
        TApplyOperator tapplyoperatorNode3;
        PExpression pexpressionNode4;
        pexpressionNode2 = (PExpression)nodeArrayList1.get(0);
        tapplyoperatorNode3 = (TApplyOperator)nodeArrayList2.get(0);
        pexpressionNode4 = (PExpression)nodeArrayList3.get(0);

        papplyexpressionNode1 = new AApplyExpression(pexpressionNode2, tapplyoperatorNode3, pexpressionNode4);
        }
	nodeList.add(papplyexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new129() /* reduce AAssignmentExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAssignmentExpression passignmentexpressionNode1;
        {
            // Block
        PLeftExpression pleftexpressionNode2;
        TAssignmentOperator tassignmentoperatorNode3;
        PExpression pexpressionNode4;
        pleftexpressionNode2 = (PLeftExpression)nodeArrayList1.get(0);
        tassignmentoperatorNode3 = (TAssignmentOperator)nodeArrayList2.get(0);
        pexpressionNode4 = (PExpression)nodeArrayList3.get(0);

        passignmentexpressionNode1 = new AAssignmentExpression(pleftexpressionNode2, tassignmentoperatorNode3, pexpressionNode4);
        }
	nodeList.add(passignmentexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new130() /* reduce ALetAssignment */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PLetAssignment pletassignmentNode1;
        {
            // Block
        TUnqualifiedIdentifier tunqualifiedidentifierNode2;
        TAssignmentOperator tassignmentoperatorNode3;
        PExpression pexpressionNode4;
        tunqualifiedidentifierNode2 = (TUnqualifiedIdentifier)nodeArrayList1.get(0);
        tassignmentoperatorNode3 = (TAssignmentOperator)nodeArrayList2.get(0);
        pexpressionNode4 = (PExpression)nodeArrayList3.get(0);

        pletassignmentNode1 = new ALetAssignment(tunqualifiedidentifierNode2, tassignmentoperatorNode3, pexpressionNode4);
        }
	nodeList.add(pletassignmentNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new131() /* reduce AOneLetAssignmentList */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PLetAssignmentList pletassignmentlistNode1;
        {
            // Block
        PLetAssignment pletassignmentNode2;
        pletassignmentNode2 = (PLetAssignment)nodeArrayList1.get(0);

        pletassignmentlistNode1 = new AOneLetAssignmentList(pletassignmentNode2);
        }
	nodeList.add(pletassignmentlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new132() /* reduce AManyLetAssignmentList */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PLetAssignmentList pletassignmentlistNode1;
        {
            // Block
        PLetAssignmentList pletassignmentlistNode2;
        TSemicolon tsemicolonNode3;
        PLetAssignment pletassignmentNode4;
        pletassignmentlistNode2 = (PLetAssignmentList)nodeArrayList1.get(0);
        tsemicolonNode3 = (TSemicolon)nodeArrayList2.get(0);
        pletassignmentNode4 = (PLetAssignment)nodeArrayList3.get(0);

        pletassignmentlistNode1 = new AManyLetAssignmentList(pletassignmentlistNode2, tsemicolonNode3, pletassignmentNode4);
        }
	nodeList.add(pletassignmentlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new133() /* reduce ALetExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PLetExpression pletexpressionNode1;
        {
            // Block
        TLet tletNode2;
        TLparen tlparenNode3;
        PLetAssignmentList pletassignmentlistNode4;
        TRparen trparenNode5;
        PExpression pexpressionNode6;
        tletNode2 = (TLet)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        pletassignmentlistNode4 = (PLetAssignmentList)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);
        pexpressionNode6 = (PExpression)nodeArrayList5.get(0);

        pletexpressionNode1 = new ALetExpression(tletNode2, tlparenNode3, pletassignmentlistNode4, trparenNode5, pexpressionNode6);
        }
	nodeList.add(pletexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new134() /* reduce AExceptExpressionClause */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExceptExpressionClause pexceptexpressionclauseNode1;
        {
            // Block
        TExcept texceptNode2;
        TLparen tlparenNode3;
        PTypedVariableDeclaration ptypedvariabledeclarationNode4;
        TRparen trparenNode5;
        PExpression pexpressionNode6;
        texceptNode2 = (TExcept)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        ptypedvariabledeclarationNode4 = (PTypedVariableDeclaration)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);
        pexpressionNode6 = (PExpression)nodeArrayList5.get(0);

        pexceptexpressionclauseNode1 = new AExceptExpressionClause(texceptNode2, tlparenNode3, ptypedvariabledeclarationNode4, trparenNode5, pexpressionNode6);
        }
	nodeList.add(pexceptexpressionclauseNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new135() /* reduce AFinallyExpressionClause */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFinallyExpressionClause pfinallyexpressionclauseNode1;
        {
            // Block
        TFinally tfinallyNode2;
        PExpression pexpressionNode3;
        tfinallyNode2 = (TFinally)nodeArrayList1.get(0);
        pexpressionNode3 = (PExpression)nodeArrayList2.get(0);

        pfinallyexpressionclauseNode1 = new AFinallyExpressionClause(tfinallyNode2, pexpressionNode3);
        }
	nodeList.add(pfinallyexpressionclauseNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new136() /* reduce AAtryexpression1TryExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTryExpression ptryexpressionNode1;
        {
            // Block
        TTry ttryNode2;
        PExpression pexpressionNode3;
        LinkedList listNode4 = new LinkedList();
        PFinallyExpressionClause pfinallyexpressionclauseNode5;
        ttryNode2 = (TTry)nodeArrayList1.get(0);
        pexpressionNode3 = (PExpression)nodeArrayList2.get(0);
        {
            // Block
        }
        pfinallyexpressionclauseNode5 = (PFinallyExpressionClause)nodeArrayList3.get(0);

        ptryexpressionNode1 = new ATryExpression(ttryNode2, pexpressionNode3, listNode4, pfinallyexpressionclauseNode5);
        }
	nodeList.add(ptryexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new137() /* reduce AAtryexpression2TryExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTryExpression ptryexpressionNode1;
        {
            // Block
        TTry ttryNode2;
        PExpression pexpressionNode3;
        LinkedList listNode5 = new LinkedList();
        PFinallyExpressionClause pfinallyexpressionclauseNode6;
        ttryNode2 = (TTry)nodeArrayList1.get(0);
        pexpressionNode3 = (PExpression)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null)
	{
	  listNode5.addAll(listNode4);
	}
        }
        pfinallyexpressionclauseNode6 = (PFinallyExpressionClause)nodeArrayList4.get(0);

        ptryexpressionNode1 = new ATryExpression(ttryNode2, pexpressionNode3, listNode5, pfinallyexpressionclauseNode6);
        }
	nodeList.add(ptryexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new138() /* reduce AForExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList9 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList8 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PForExpression pforexpressionNode1;
        {
            // Block
        TFor tforNode2;
        TLparen tlparenNode3;
        PLetAssignment pletassignmentNode4;
        TSemicolon tsemicolonNode5;
        PExpression pexpressionNode6;
        TSemicolon tsemicolonNode7;
        PExpression pexpressionNode8;
        TRparen trparenNode9;
        PExpression pexpressionNode10;
        tforNode2 = (TFor)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        pletassignmentNode4 = (PLetAssignment)nodeArrayList3.get(0);
        tsemicolonNode5 = (TSemicolon)nodeArrayList4.get(0);
        pexpressionNode6 = (PExpression)nodeArrayList5.get(0);
        tsemicolonNode7 = (TSemicolon)nodeArrayList6.get(0);
        pexpressionNode8 = (PExpression)nodeArrayList7.get(0);
        trparenNode9 = (TRparen)nodeArrayList8.get(0);
        pexpressionNode10 = (PExpression)nodeArrayList9.get(0);

        pforexpressionNode1 = new AForExpression(tforNode2, tlparenNode3, pletassignmentNode4, tsemicolonNode5, pexpressionNode6, tsemicolonNode7, pexpressionNode8, trparenNode9, pexpressionNode10);
        }
	nodeList.add(pforexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new139() /* reduce AWhileExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PWhileExpression pwhileexpressionNode1;
        {
            // Block
        TWhile twhileNode2;
        TLparen tlparenNode3;
        PExpression pexpressionNode4;
        TRparen trparenNode5;
        PExpression pexpressionNode6;
        twhileNode2 = (TWhile)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        pexpressionNode4 = (PExpression)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);
        pexpressionNode6 = (PExpression)nodeArrayList5.get(0);

        pwhileexpressionNode1 = new AWhileExpression(twhileNode2, tlparenNode3, pexpressionNode4, trparenNode5, pexpressionNode6);
        }
	nodeList.add(pwhileexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new140() /* reduce ADoExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PDoExpression pdoexpressionNode1;
        {
            // Block
        TDo tdoNode2;
        PExpression pexpressionNode3;
        TUntil tuntilNode4;
        PExpression pexpressionNode5;
        tdoNode2 = (TDo)nodeArrayList1.get(0);
        pexpressionNode3 = (PExpression)nodeArrayList2.get(0);
        tuntilNode4 = (TUntil)nodeArrayList3.get(0);
        pexpressionNode5 = (PExpression)nodeArrayList4.get(0);

        pdoexpressionNode1 = new ADoExpression(tdoNode2, pexpressionNode3, tuntilNode4, pexpressionNode5);
        }
	nodeList.add(pdoexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new141() /* reduce AThrowExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PThrowExpression pthrowexpressionNode1;
        {
            // Block
        TThrow tthrowNode2;
        PExpression pexpressionNode3;
        tthrowNode2 = (TThrow)nodeArrayList1.get(0);
        pexpressionNode3 = (PExpression)nodeArrayList2.get(0);

        pthrowexpressionNode1 = new AThrowExpression(tthrowNode2, pexpressionNode3);
        }
	nodeList.add(pthrowexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new142() /* reduce ACaseExpressionClause */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PCaseExpressionClause pcaseexpressionclauseNode1;
        {
            // Block
        TCase tcaseNode2;
        TLparen tlparenNode3;
        PExpression pexpressionNode4;
        TRparen trparenNode5;
        PExpression pexpressionNode6;
        tcaseNode2 = (TCase)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        pexpressionNode4 = (PExpression)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);
        pexpressionNode6 = (PExpression)nodeArrayList5.get(0);

        pcaseexpressionclauseNode1 = new ACaseExpressionClause(tcaseNode2, tlparenNode3, pexpressionNode4, trparenNode5, pexpressionNode6);
        }
	nodeList.add(pcaseexpressionclauseNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new143() /* reduce AOneCondExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PCondExpression pcondexpressionNode1;
        {
            // Block
        TCond tcondNode2;
        PCaseExpressionClause pcaseexpressionclauseNode3;
        tcondNode2 = (TCond)nodeArrayList1.get(0);
        pcaseexpressionclauseNode3 = (PCaseExpressionClause)nodeArrayList2.get(0);

        pcondexpressionNode1 = new AOneCondExpression(tcondNode2, pcaseexpressionclauseNode3);
        }
	nodeList.add(pcondexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new144() /* reduce AManyCondExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PCondExpression pcondexpressionNode1;
        {
            // Block
        TCond tcondNode2;
        TLbracket tlbracketNode3;
        LinkedList listNode5 = new LinkedList();
        TRbracket trbracketNode6;
        tcondNode2 = (TCond)nodeArrayList1.get(0);
        tlbracketNode3 = (TLbracket)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null)
	{
	  listNode5.addAll(listNode4);
	}
        }
        trbracketNode6 = (TRbracket)nodeArrayList4.get(0);

        pcondexpressionNode1 = new AManyCondExpression(tcondNode2, tlbracketNode3, listNode5, trbracketNode6);
        }
	nodeList.add(pcondexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new145() /* reduce ACastExpressionClause */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PCastExpressionClause pcastexpressionclauseNode1;
        {
            // Block
        TCase tcaseNode2;
        TLparen tlparenNode3;
        PTypedVariableDefinition ptypedvariabledefinitionNode4;
        TRparen trparenNode5;
        PExpression pexpressionNode6;
        tcaseNode2 = (TCase)nodeArrayList1.get(0);
        tlparenNode3 = (TLparen)nodeArrayList2.get(0);
        ptypedvariabledefinitionNode4 = (PTypedVariableDefinition)nodeArrayList3.get(0);
        trparenNode5 = (TRparen)nodeArrayList4.get(0);
        pexpressionNode6 = (PExpression)nodeArrayList5.get(0);

        pcastexpressionclauseNode1 = new ACastExpressionClause(tcaseNode2, tlparenNode3, ptypedvariabledefinitionNode4, trparenNode5, pexpressionNode6);
        }
	nodeList.add(pcastexpressionclauseNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new146() /* reduce AOneCastExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PCastExpression pcastexpressionNode1;
        {
            // Block
        TCast tcastNode2;
        PCastExpressionClause pcastexpressionclauseNode3;
        TElse telseNode4;
        PExpression pexpressionNode5;
        tcastNode2 = (TCast)nodeArrayList1.get(0);
        pcastexpressionclauseNode3 = (PCastExpressionClause)nodeArrayList2.get(0);
        telseNode4 = (TElse)nodeArrayList3.get(0);
        pexpressionNode5 = (PExpression)nodeArrayList4.get(0);

        pcastexpressionNode1 = new AOneCastExpression(tcastNode2, pcastexpressionclauseNode3, telseNode4, pexpressionNode5);
        }
	nodeList.add(pcastexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new147() /* reduce AManyCastExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PCastExpression pcastexpressionNode1;
        {
            // Block
        TCast tcastNode2;
        TLbracket tlbracketNode3;
        LinkedList listNode5 = new LinkedList();
        TRbracket trbracketNode6;
        TElse telseNode7;
        PExpression pexpressionNode8;
        tcastNode2 = (TCast)nodeArrayList1.get(0);
        tlbracketNode3 = (TLbracket)nodeArrayList2.get(0);
        {
            // Block
        LinkedList listNode4 = new LinkedList();
        listNode4 = (LinkedList)nodeArrayList3.get(0);
	if(listNode4 != null)
	{
	  listNode5.addAll(listNode4);
	}
        }
        trbracketNode6 = (TRbracket)nodeArrayList4.get(0);
        telseNode7 = (TElse)nodeArrayList5.get(0);
        pexpressionNode8 = (PExpression)nodeArrayList6.get(0);

        pcastexpressionNode1 = new AManyCastExpression(tcastNode2, tlbracketNode3, listNode5, trbracketNode6, telseNode7, pexpressionNode8);
        }
	nodeList.add(pcastexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new148() /* reduce AOneExpressionBlock */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpressionBlock pexpressionblockNode1;
        {
            // Block
        PExpression pexpressionNode2;
        pexpressionNode2 = (PExpression)nodeArrayList1.get(0);

        pexpressionblockNode1 = new AOneExpressionBlock(pexpressionNode2);
        }
	nodeList.add(pexpressionblockNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new149() /* reduce AManyExpressionBlock */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpressionBlock pexpressionblockNode1;
        {
            // Block
        PExpressionBlock pexpressionblockNode2;
        TSemicolon tsemicolonNode3;
        PExpression pexpressionNode4;
        pexpressionblockNode2 = (PExpressionBlock)nodeArrayList1.get(0);
        tsemicolonNode3 = (TSemicolon)nodeArrayList2.get(0);
        pexpressionNode4 = (PExpression)nodeArrayList3.get(0);

        pexpressionblockNode1 = new AManyExpressionBlock(pexpressionblockNode2, tsemicolonNode3, pexpressionNode4);
        }
	nodeList.add(pexpressionblockNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new150() /* reduce ABlockExpression */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PBlockExpression pblockexpressionNode1;
        {
            // Block
        TLbracket tlbracketNode2;
        PExpressionBlock pexpressionblockNode3;
        TRbracket trbracketNode4;
        tlbracketNode2 = (TLbracket)nodeArrayList1.get(0);
        pexpressionblockNode3 = (PExpressionBlock)nodeArrayList2.get(0);
        trbracketNode4 = (TRbracket)nodeArrayList3.get(0);

        pblockexpressionNode1 = new ABlockExpression(tlbracketNode2, pexpressionblockNode3, trbracketNode4);
        }
	nodeList.add(pblockexpressionNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new151() /* reduce ATerminal$ImportDeclaration */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PImportDeclaration pimportdeclarationNode1;
        pimportdeclarationNode1 = (PImportDeclaration)nodeArrayList1.get(0);
	if(pimportdeclarationNode1 != null)
	{
	  listNode2.add(pimportdeclarationNode1);
	}
        }
	nodeList.add(listNode2);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new152() /* reduce ANonTerminal$ImportDeclaration */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PImportDeclaration pimportdeclarationNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pimportdeclarationNode2 = (PImportDeclaration)nodeArrayList2.get(0);
	if(listNode1 != null)
	{
	  listNode3.addAll(listNode1);
	}
	if(pimportdeclarationNode2 != null)
	{
	  listNode3.add(pimportdeclarationNode2);
	}
        }
	nodeList.add(listNode3);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new153() /* reduce ATerminal$Definition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PDefinition pdefinitionNode1;
        pdefinitionNode1 = (PDefinition)nodeArrayList1.get(0);
	if(pdefinitionNode1 != null)
	{
	  listNode2.add(pdefinitionNode1);
	}
        }
	nodeList.add(listNode2);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new154() /* reduce ANonTerminal$Definition */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PDefinition pdefinitionNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pdefinitionNode2 = (PDefinition)nodeArrayList2.get(0);
	if(listNode1 != null)
	{
	  listNode3.addAll(listNode1);
	}
	if(pdefinitionNode2 != null)
	{
	  listNode3.add(pdefinitionNode2);
	}
        }
	nodeList.add(listNode3);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new155() /* reduce ATerminal$MemberDeclaration */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PMemberDeclaration pmemberdeclarationNode1;
        pmemberdeclarationNode1 = (PMemberDeclaration)nodeArrayList1.get(0);
	if(pmemberdeclarationNode1 != null)
	{
	  listNode2.add(pmemberdeclarationNode1);
	}
        }
	nodeList.add(listNode2);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new156() /* reduce ANonTerminal$MemberDeclaration */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PMemberDeclaration pmemberdeclarationNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pmemberdeclarationNode2 = (PMemberDeclaration)nodeArrayList2.get(0);
	if(listNode1 != null)
	{
	  listNode3.addAll(listNode1);
	}
	if(pmemberdeclarationNode2 != null)
	{
	  listNode3.add(pmemberdeclarationNode2);
	}
        }
	nodeList.add(listNode3);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new157() /* reduce ATerminal$ExceptExpressionClause */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PExceptExpressionClause pexceptexpressionclauseNode1;
        pexceptexpressionclauseNode1 = (PExceptExpressionClause)nodeArrayList1.get(0);
	if(pexceptexpressionclauseNode1 != null)
	{
	  listNode2.add(pexceptexpressionclauseNode1);
	}
        }
	nodeList.add(listNode2);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new158() /* reduce ANonTerminal$ExceptExpressionClause */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PExceptExpressionClause pexceptexpressionclauseNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pexceptexpressionclauseNode2 = (PExceptExpressionClause)nodeArrayList2.get(0);
	if(listNode1 != null)
	{
	  listNode3.addAll(listNode1);
	}
	if(pexceptexpressionclauseNode2 != null)
	{
	  listNode3.add(pexceptexpressionclauseNode2);
	}
        }
	nodeList.add(listNode3);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new159() /* reduce ATerminal$CaseExpressionClause */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PCaseExpressionClause pcaseexpressionclauseNode1;
        pcaseexpressionclauseNode1 = (PCaseExpressionClause)nodeArrayList1.get(0);
	if(pcaseexpressionclauseNode1 != null)
	{
	  listNode2.add(pcaseexpressionclauseNode1);
	}
        }
	nodeList.add(listNode2);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new160() /* reduce ANonTerminal$CaseExpressionClause */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PCaseExpressionClause pcaseexpressionclauseNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pcaseexpressionclauseNode2 = (PCaseExpressionClause)nodeArrayList2.get(0);
	if(listNode1 != null)
	{
	  listNode3.addAll(listNode1);
	}
	if(pcaseexpressionclauseNode2 != null)
	{
	  listNode3.add(pcaseexpressionclauseNode2);
	}
        }
	nodeList.add(listNode3);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new161() /* reduce ATerminal$CastExpressionClause */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode2 = new LinkedList();
        {
            // Block
        PCastExpressionClause pcastexpressionclauseNode1;
        pcastexpressionclauseNode1 = (PCastExpressionClause)nodeArrayList1.get(0);
	if(pcastexpressionclauseNode1 != null)
	{
	  listNode2.add(pcastexpressionclauseNode1);
	}
        }
	nodeList.add(listNode2);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new162() /* reduce ANonTerminal$CastExpressionClause */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        LinkedList listNode3 = new LinkedList();
        {
            // Block
        LinkedList listNode1 = new LinkedList();
        PCastExpressionClause pcastexpressionclauseNode2;
        listNode1 = (LinkedList)nodeArrayList1.get(0);
        pcastexpressionclauseNode2 = (PCastExpressionClause)nodeArrayList2.get(0);
	if(listNode1 != null)
	{
	  listNode3.addAll(listNode1);
	}
	if(pcastexpressionclauseNode2 != null)
	{
	  listNode3.add(pcastexpressionclauseNode2);
	}
        }
	nodeList.add(listNode3);
        return nodeList;
    }



    private static int[][][] actionTable;
/*      {
			{{-1, ERROR, 0}, {29, SHIFT, 1}, },
			{{-1, ERROR, 1}, {67, SHIFT, 3}, },
			{{-1, ERROR, 2}, {70, ACCEPT, -1}, },
			{{-1, ERROR, 3}, {16, SHIFT, 4}, {17, SHIFT, 5}, {28, SHIFT, 6}, {29, SHIFT, 1}, {32, SHIFT, 7}, {33, SHIFT, 8}, {45, SHIFT, 9}, {62, SHIFT, 10}, },
			{{-1, ERROR, 4}, {67, SHIFT, 19}, },
			{{-1, ERROR, 5}, {67, SHIFT, 19}, },
			{{-1, REDUCE, 0}, },
			{{-1, ERROR, 7}, {67, SHIFT, 19}, },
			{{-1, ERROR, 8}, {0, SHIFT, 23}, {67, SHIFT, 24}, },
			{{-1, ERROR, 9}, {67, SHIFT, 27}, },
			{{-1, ERROR, 10}, {67, SHIFT, 28}, },
			{{-1, REDUCE, 39}, },
			{{-1, REDUCE, 151}, },
			{{-1, REDUCE, 38}, },
			{{-1, REDUCE, 153}, },
			{{-1, REDUCE, 37}, },
			{{-1, REDUCE, 40}, },
			{{-1, ERROR, 17}, {16, SHIFT, 4}, {17, SHIFT, 5}, {28, SHIFT, 29}, {29, SHIFT, 1}, {32, SHIFT, 7}, {33, SHIFT, 8}, {45, SHIFT, 9}, {62, SHIFT, 10}, },
			{{-1, ERROR, 18}, {16, SHIFT, 4}, {17, SHIFT, 5}, {28, SHIFT, 32}, {29, SHIFT, 1}, {33, SHIFT, 8}, {45, SHIFT, 9}, {62, SHIFT, 10}, },
			{{-1, REDUCE, 4}, },
			{{-1, ERROR, 20}, {26, SHIFT, 34}, {67, SHIFT, 35}, },
			{{-1, ERROR, 21}, {20, SHIFT, 36}, {26, SHIFT, 34}, },
			{{-1, ERROR, 22}, {26, SHIFT, 34}, {27, SHIFT, 37}, },
			{{-1, ERROR, 23}, {67, SHIFT, 24}, },
			{{-1, ERROR, 24}, {61, SHIFT, 39}, },
			{{-1, ERROR, 25}, {19, SHIFT, 40}, },
			{{-1, ERROR, 26}, {27, SHIFT, 41}, },
			{{-1, ERROR, 27}, {20, SHIFT, 42}, },
			{{-1, ERROR, 28}, {41, SHIFT, 43}, },
			{{-1, REDUCE, 1}, },
			{{-1, REDUCE, 152}, },
			{{-1, ERROR, 31}, {16, SHIFT, 4}, {17, SHIFT, 5}, {28, SHIFT, 44}, {29, SHIFT, 1}, {33, SHIFT, 8}, {45, SHIFT, 9}, {62, SHIFT, 10}, },
			{{-1, REDUCE, 2}, },
			{{-1, REDUCE, 154}, },
			{{-1, ERROR, 34}, {67, SHIFT, 45}, },
			{{-1, ERROR, 35}, {20, SHIFT, 46}, },
			{{-1, ERROR, 36}, {67, SHIFT, 47}, },
			{{-1, REDUCE, 11}, },
			{{-1, ERROR, 38}, {27, SHIFT, 50}, },
			{{-1, ERROR, 39}, {61, SHIFT, 51}, {67, SHIFT, 19}, },
			{{-1, ERROR, 40}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, REDUCE, 47}, },
			{{-1, ERROR, 42}, {67, SHIFT, 47}, },
			{{-1, ERROR, 43}, {37, SHIFT, 99}, {38, SHIFT, 100}, {39, SHIFT, 101}, {40, SHIFT, 102}, {45, SHIFT, 103}, {63, SHIFT, 104}, {67, SHIFT, 19}, },
			{{-1, REDUCE, 3}, },
			{{-1, REDUCE, 5}, },
			{{-1, ERROR, 46}, {16, SHIFT, 114}, {67, SHIFT, 47}, },
			{{-1, REDUCE, 57}, {67, SHIFT, 19}, },
			{{-1, REDUCE, 61}, },
			{{-1, ERROR, 49}, {18, SHIFT, 119}, {21, SHIFT, 120}, },
			{{-1, REDUCE, 48}, },
			{{-1, ERROR, 51}, {67, SHIFT, 19}, },
			{{-1, REDUCE, 41}, {26, SHIFT, 34}, {30, SHIFT, 122}, },
			{{-1, REDUCE, 45}, },
			{{-1, REDUCE, 121}, },
			{{-1, ERROR, 55}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 56}, {20, SHIFT, 58}, {67, SHIFT, 19}, },
			{{-1, ERROR, 57}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 58}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 59}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 60}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 61}, {20, SHIFT, 135}, },
			{{-1, ERROR, 62}, {20, SHIFT, 136}, },
			{{-1, ERROR, 63}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 64}, {20, SHIFT, 138}, },
			{{-1, ERROR, 65}, {22, SHIFT, 139}, {52, SHIFT, 140}, },
			{{-1, ERROR, 66}, {20, SHIFT, 142}, },
			{{-1, ERROR, 67}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 68}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 69}, {22, SHIFT, 145}, {52, SHIFT, 146}, },
			{{-1, REDUCE, 123}, },
			{{-1, REDUCE, 120}, },
			{{-1, REDUCE, 122}, },
			{{-1, REDUCE, 117}, {20, SHIFT, 148}, {26, SHIFT, 34}, },
			{{-1, REDUCE, 46}, },
			{{-1, REDUCE, 80}, },
			{{-1, REDUCE, 87}, {13, SHIFT, 149}, {30, SHIFT, 150}, {31, SHIFT, 151}, {41, SHIFT, 152}, {42, SHIFT, 153}, {43, SHIFT, 154}, {44, SHIFT, 155}, },
			{{-1, REDUCE, 89}, {6, SHIFT, 156}, {7, SHIFT, 157}, },
			{{-1, REDUCE, 92}, {4, SHIFT, 158}, {5, SHIFT, 159}, },
			{{-1, REDUCE, 95}, {8, SHIFT, 160}, {9, SHIFT, 161}, {10, SHIFT, 162}, },
			{{-1, REDUCE, 99}, {12, SHIFT, 163}, },
			{{-1, REDUCE, 101}, },
			{{-1, REDUCE, 105}, },
			{{-1, REDUCE, 109}, {20, SHIFT, 164}, {24, SHIFT, 165}, },
			{{-1, REDUCE, 110}, {19, SHIFT, 167}, {24, SHIFT, 165}, },
			{{-1, REDUCE, 106}, },
			{{-1, REDUCE, 107}, },
			{{-1, REDUCE, 108}, },
			{{-1, REDUCE, 70}, },
			{{-1, REDUCE, 71}, },
			{{-1, REDUCE, 72}, },
			{{-1, REDUCE, 73}, },
			{{-1, REDUCE, 74}, },
			{{-1, REDUCE, 75}, },
			{{-1, REDUCE, 76}, },
			{{-1, REDUCE, 77}, },
			{{-1, REDUCE, 79}, },
			{{-1, REDUCE, 78}, },
			{{-1, ERROR, 98}, {18, SHIFT, 119}, {21, SHIFT, 169}, },
			{{-1, ERROR, 99}, {22, SHIFT, 170}, {30, SHIFT, 122}, {36, SHIFT, 171}, },
			{{-1, ERROR, 100}, {20, SHIFT, 174}, },
			{{-1, ERROR, 101}, {20, SHIFT, 175}, },
			{{-1, ERROR, 102}, {20, SHIFT, 176}, },
			{{-1, ERROR, 103}, {20, SHIFT, 177}, {67, SHIFT, 19}, },
			{{-1, ERROR, 104}, {36, SHIFT, 171}, },
			{{-1, REDUCE, 20}, {26, SHIFT, 34}, {61, SHIFT, 180}, },
			{{-1, REDUCE, 12}, },
			{{-1, REDUCE, 13}, },
			{{-1, REDUCE, 14}, },
			{{-1, REDUCE, 15}, },
			{{-1, REDUCE, 16}, },
			{{-1, REDUCE, 17}, },
			{{-1, REDUCE, 18}, },
			{{-1, REDUCE, 19}, },
			{{-1, ERROR, 114}, {67, SHIFT, 181}, },
			{{-1, REDUCE, 60}, },
			{{-1, REDUCE, 63}, },
			{{-1, ERROR, 117}, {18, SHIFT, 182}, {21, SHIFT, 183}, },
			{{-1, REDUCE, 58}, {26, SHIFT, 34}, },
			{{-1, ERROR, 119}, {67, SHIFT, 47}, },
			{{-1, ERROR, 120}, {22, SHIFT, 59}, },
			{{-1, REDUCE, 42}, {26, SHIFT, 34}, {30, SHIFT, 122}, },
			{{-1, ERROR, 122}, {67, SHIFT, 187}, },
			{{-1, REDUCE, 43}, },
			{{-1, REDUCE, 103}, },
			{{-1, REDUCE, 110}, {24, SHIFT, 165}, },
			{{-1, REDUCE, 117}, {26, SHIFT, 34}, },
			{{-1, ERROR, 127}, {24, SHIFT, 165}, },
			{{-1, REDUCE, 104}, {24, SHIFT, 165}, },
			{{-1, REDUCE, 102}, },
			{{-1, ERROR, 130}, {21, SHIFT, 189}, },
			{{-1, REDUCE, 148}, },
			{{-1, ERROR, 132}, {23, SHIFT, 190}, {27, SHIFT, 191}, },
			{{-1, REDUCE, 124}, },
			{{-1, ERROR, 134}, {18, SHIFT, 192}, {25, SHIFT, 193}, },
			{{-1, ERROR, 135}, {67, SHIFT, 47}, },
			{{-1, ERROR, 136}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 137}, {50, SHIFT, 196}, },
			{{-1, ERROR, 138}, {67, SHIFT, 197}, },
			{{-1, ERROR, 139}, {52, SHIFT, 140}, },
			{{-1, ERROR, 140}, {20, SHIFT, 201}, },
			{{-1, REDUCE, 143}, },
			{{-1, ERROR, 142}, {67, SHIFT, 197}, },
			{{-1, ERROR, 143}, {55, SHIFT, 204}, {56, SHIFT, 205}, },
			{{-1, REDUCE, 141}, },
			{{-1, ERROR, 145}, {52, SHIFT, 146}, },
			{{-1, ERROR, 146}, {20, SHIFT, 211}, },
			{{-1, ERROR, 147}, {59, SHIFT, 212}, },
			{{-1, ERROR, 148}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {21, SHIFT, 213}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 149}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 150}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 151}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 152}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 153}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 154}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 155}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 156}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 157}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 158}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 159}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 160}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 161}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 162}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 163}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {24, SHIFT, 60}, {46, SHIFT, 61}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 164}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {21, SHIFT, 230}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 165}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, REDUCE, 119}, },
			{{-1, ERROR, 167}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, REDUCE, 118}, },
			{{-1, ERROR, 169}, {22, SHIFT, 59}, },
			{{-1, ERROR, 170}, {1, SHIFT, 235}, {34, SHIFT, 236}, {35, SHIFT, 237}, {61, SHIFT, 51}, {67, SHIFT, 238}, },
			{{-1, ERROR, 171}, {67, SHIFT, 19}, },
			{{-1, ERROR, 172}, {22, SHIFT, 244}, {36, SHIFT, 171}, },
			{{-1, ERROR, 173}, {22, SHIFT, 246}, },
			{{-1, ERROR, 174}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 175}, {67, SHIFT, 248}, },
			{{-1, ERROR, 176}, {67, SHIFT, 248}, },
			{{-1, ERROR, 177}, {67, SHIFT, 47}, },
			{{-1, ERROR, 178}, {20, SHIFT, 252}, {26, SHIFT, 34}, },
			{{-1, ERROR, 179}, {22, SHIFT, 253}, },
			{{-1, ERROR, 180}, {9, SHIFT, 254}, {27, SHIFT, 255}, },
			{{-1, ERROR, 181}, {67, SHIFT, 19}, },
			{{-1, ERROR, 182}, {16, SHIFT, 114}, {67, SHIFT, 47}, },
			{{-1, ERROR, 183}, {22, SHIFT, 59}, {27, SHIFT, 259}, },
			{{-1, REDUCE, 62}, },
			{{-1, REDUCE, 68}, },
			{{-1, REDUCE, 44}, },
			{{-1, REDUCE, 8}, },
			{{-1, ERROR, 188}, {18, SHIFT, 262}, {31, SHIFT, 263}, },
			{{-1, REDUCE, 115}, },
			{{-1, REDUCE, 150}, },
			{{-1, ERROR, 191}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 192}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, REDUCE, 126}, },
			{{-1, ERROR, 194}, {18, SHIFT, 119}, {21, SHIFT, 266}, },
			{{-1, ERROR, 195}, {21, SHIFT, 267}, },
			{{-1, ERROR, 196}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 197}, {19, SHIFT, 269}, },
			{{-1, ERROR, 198}, {27, SHIFT, 270}, },
			{{-1, REDUCE, 159}, },
			{{-1, ERROR, 200}, {23, SHIFT, 271}, {52, SHIFT, 140}, },
			{{-1, ERROR, 201}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, REDUCE, 131}, },
			{{-1, ERROR, 203}, {21, SHIFT, 274}, {27, SHIFT, 275}, },
			{{-1, ERROR, 204}, {20, SHIFT, 276}, },
			{{-1, ERROR, 205}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, REDUCE, 157}, },
			{{-1, REDUCE, 136}, },
			{{-1, ERROR, 208}, {55, SHIFT, 204}, {56, SHIFT, 205}, },
			{{-1, REDUCE, 161}, },
			{{-1, ERROR, 210}, {23, SHIFT, 280}, {52, SHIFT, 146}, },
			{{-1, ERROR, 211}, {67, SHIFT, 24}, },
			{{-1, ERROR, 212}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, REDUCE, 111}, },
			{{-1, ERROR, 214}, {18, SHIFT, 192}, {21, SHIFT, 284}, },
			{{-1, REDUCE, 88}, {6, SHIFT, 156}, {7, SHIFT, 157}, },
			{{-1, REDUCE, 83}, {13, SHIFT, 149}, },
			{{-1, REDUCE, 81}, {13, SHIFT, 149}, },
			{{-1, REDUCE, 85}, {13, SHIFT, 149}, },
			{{-1, REDUCE, 86}, {13, SHIFT, 149}, },
			{{-1, REDUCE, 82}, {13, SHIFT, 149}, },
			{{-1, REDUCE, 84}, {13, SHIFT, 149}, },
			{{-1, REDUCE, 90}, {4, SHIFT, 158}, {5, SHIFT, 159}, },
			{{-1, REDUCE, 91}, {4, SHIFT, 158}, {5, SHIFT, 159}, },
			{{-1, REDUCE, 93}, {8, SHIFT, 160}, {9, SHIFT, 161}, {10, SHIFT, 162}, },
			{{-1, REDUCE, 94}, {8, SHIFT, 160}, {9, SHIFT, 161}, {10, SHIFT, 162}, },
			{{-1, REDUCE, 96}, {12, SHIFT, 163}, },
			{{-1, REDUCE, 97}, {12, SHIFT, 163}, },
			{{-1, REDUCE, 98}, {12, SHIFT, 163}, },
			{{-1, REDUCE, 100}, },
			{{-1, REDUCE, 113}, },
			{{-1, ERROR, 231}, {18, SHIFT, 192}, {21, SHIFT, 285}, },
			{{-1, ERROR, 232}, {25, SHIFT, 286}, },
			{{-1, REDUCE, 129}, },
			{{-1, REDUCE, 69}, },
			{{-1, ERROR, 235}, {61, SHIFT, 51}, {67, SHIFT, 238}, },
			{{-1, ERROR, 236}, {67, SHIFT, 289}, },
			{{-1, ERROR, 237}, {67, SHIFT, 290}, },
			{{-1, REDUCE, 4}, {18, REDUCE, 6}, {61, REDUCE, 6}, {67, REDUCE, 6}, },
			{{-1, ERROR, 239}, {18, SHIFT, 291}, {61, SHIFT, 51}, {67, SHIFT, 19}, },
			{{-1, ERROR, 240}, {24, SHIFT, 293}, },
			{{-1, REDUCE, 155}, },
			{{-1, ERROR, 242}, {1, SHIFT, 235}, {23, SHIFT, 294}, {34, SHIFT, 236}, {35, SHIFT, 237}, {61, SHIFT, 51}, {67, SHIFT, 238}, },
			{{-1, REDUCE, 55}, {26, SHIFT, 34}, {30, SHIFT, 122}, },
			{{-1, ERROR, 244}, {1, SHIFT, 235}, {34, SHIFT, 236}, {35, SHIFT, 237}, {61, SHIFT, 51}, {67, SHIFT, 238}, },
			{{-1, ERROR, 245}, {22, SHIFT, 298}, },
			{{-1, ERROR, 246}, {1, SHIFT, 235}, {34, SHIFT, 236}, {35, SHIFT, 237}, {61, SHIFT, 51}, {67, SHIFT, 238}, },
			{{-1, ERROR, 247}, {18, SHIFT, 300}, },
			{{-1, REDUCE, 6}, },
			{{-1, ERROR, 249}, {18, SHIFT, 291}, {21, SHIFT, 301}, },
			{{-1, ERROR, 250}, {18, SHIFT, 291}, {21, SHIFT, 302}, },
			{{-1, ERROR, 251}, {18, SHIFT, 119}, {21, SHIFT, 303}, },
			{{-1, ERROR, 252}, {67, SHIFT, 47}, },
			{{-1, ERROR, 253}, {1, SHIFT, 235}, {23, SHIFT, 305}, {34, SHIFT, 236}, {35, SHIFT, 237}, {61, SHIFT, 51}, {67, SHIFT, 238}, },
			{{-1, ERROR, 254}, {64, SHIFT, 307}, },
			{{-1, REDUCE, 34}, },
			{{-1, ERROR, 256}, {27, SHIFT, 308}, },
			{{-1, REDUCE, 59}, {26, SHIFT, 34}, },
			{{-1, REDUCE, 64}, },
			{{-1, REDUCE, 65}, },
			{{-1, REDUCE, 67}, },
			{{-1, REDUCE, 66}, },
			{{-1, ERROR, 262}, {67, SHIFT, 309}, },
			{{-1, REDUCE, 10}, },
			{{-1, REDUCE, 149}, },
			{{-1, REDUCE, 125}, },
			{{-1, ERROR, 266}, {22, SHIFT, 59}, },
			{{-1, ERROR, 267}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, REDUCE, 140}, },
			{{-1, ERROR, 269}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 270}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, REDUCE, 144}, },
			{{-1, REDUCE, 160}, },
			{{-1, ERROR, 273}, {21, SHIFT, 314}, },
			{{-1, ERROR, 274}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 275}, {67, SHIFT, 197}, },
			{{-1, ERROR, 276}, {67, SHIFT, 24}, },
			{{-1, REDUCE, 135}, },
			{{-1, REDUCE, 158}, },
			{{-1, REDUCE, 137}, },
			{{-1, ERROR, 280}, {59, SHIFT, 318}, },
			{{-1, REDUCE, 162}, },
			{{-1, ERROR, 282}, {21, SHIFT, 319}, },
			{{-1, REDUCE, 146}, },
			{{-1, REDUCE, 112}, },
			{{-1, REDUCE, 114}, },
			{{-1, REDUCE, 116}, },
			{{-1, ERROR, 287}, {18, SHIFT, 291}, {61, SHIFT, 51}, {67, SHIFT, 19}, },
			{{-1, ERROR, 288}, {24, SHIFT, 321}, },
			{{-1, ERROR, 289}, {20, SHIFT, 322}, },
			{{-1, ERROR, 290}, {20, SHIFT, 323}, },
			{{-1, ERROR, 291}, {67, SHIFT, 324}, },
			{{-1, ERROR, 292}, {27, SHIFT, 325}, },
			{{-1, ERROR, 293}, {68, SHIFT, 326}, },
			{{-1, REDUCE, 21}, },
			{{-1, REDUCE, 156}, },
			{{-1, REDUCE, 56}, },
			{{-1, ERROR, 297}, {1, SHIFT, 235}, {23, SHIFT, 327}, {34, SHIFT, 236}, {35, SHIFT, 237}, {61, SHIFT, 51}, {67, SHIFT, 238}, },
			{{-1, ERROR, 298}, {1, SHIFT, 235}, {34, SHIFT, 236}, {35, SHIFT, 237}, {61, SHIFT, 51}, {67, SHIFT, 238}, },
			{{-1, ERROR, 299}, {1, SHIFT, 235}, {23, SHIFT, 329}, {34, SHIFT, 236}, {35, SHIFT, 237}, {61, SHIFT, 51}, {67, SHIFT, 238}, },
			{{-1, ERROR, 300}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 301}, {27, SHIFT, 331}, {36, SHIFT, 171}, },
			{{-1, ERROR, 302}, {27, SHIFT, 333}, {36, SHIFT, 171}, },
			{{-1, ERROR, 303}, {27, SHIFT, 335}, },
			{{-1, ERROR, 304}, {18, SHIFT, 119}, {21, SHIFT, 336}, },
			{{-1, REDUCE, 32}, },
			{{-1, ERROR, 306}, {1, SHIFT, 235}, {23, SHIFT, 337}, {34, SHIFT, 236}, {35, SHIFT, 237}, {61, SHIFT, 51}, {67, SHIFT, 238}, },
			{{-1, REDUCE, 36}, },
			{{-1, REDUCE, 35}, },
			{{-1, REDUCE, 9}, },
			{{-1, REDUCE, 127}, },
			{{-1, REDUCE, 139}, },
			{{-1, REDUCE, 130}, },
			{{-1, ERROR, 313}, {27, SHIFT, 338}, },
			{{-1, ERROR, 314}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, REDUCE, 133}, },
			{{-1, REDUCE, 132}, },
			{{-1, ERROR, 317}, {21, SHIFT, 340}, },
			{{-1, ERROR, 318}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 319}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 320}, {27, SHIFT, 343}, },
			{{-1, ERROR, 321}, {68, SHIFT, 344}, },
			{{-1, ERROR, 322}, {67, SHIFT, 47}, },
			{{-1, ERROR, 323}, {67, SHIFT, 47}, },
			{{-1, REDUCE, 7}, },
			{{-1, REDUCE, 49}, },
			{{-1, ERROR, 326}, {25, SHIFT, 347}, },
			{{-1, REDUCE, 22}, },
			{{-1, ERROR, 328}, {1, SHIFT, 235}, {23, SHIFT, 348}, {34, SHIFT, 236}, {35, SHIFT, 237}, {61, SHIFT, 51}, {67, SHIFT, 238}, },
			{{-1, REDUCE, 23}, },
			{{-1, ERROR, 330}, {21, SHIFT, 349}, },
			{{-1, REDUCE, 26}, },
			{{-1, ERROR, 332}, {27, SHIFT, 350}, },
			{{-1, REDUCE, 28}, },
			{{-1, ERROR, 334}, {27, SHIFT, 351}, },
			{{-1, REDUCE, 30}, },
			{{-1, ERROR, 336}, {27, SHIFT, 352}, },
			{{-1, REDUCE, 33}, },
			{{-1, ERROR, 338}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, REDUCE, 142}, },
			{{-1, ERROR, 340}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, REDUCE, 147}, },
			{{-1, REDUCE, 145}, },
			{{-1, REDUCE, 50}, },
			{{-1, ERROR, 344}, {25, SHIFT, 355}, },
			{{-1, ERROR, 345}, {18, SHIFT, 119}, {21, SHIFT, 356}, },
			{{-1, ERROR, 346}, {18, SHIFT, 119}, {21, SHIFT, 357}, },
			{{-1, ERROR, 347}, {27, SHIFT, 358}, },
			{{-1, REDUCE, 24}, },
			{{-1, ERROR, 349}, {36, SHIFT, 171}, },
			{{-1, REDUCE, 27}, },
			{{-1, REDUCE, 29}, },
			{{-1, REDUCE, 31}, },
			{{-1, ERROR, 353}, {21, SHIFT, 360}, },
			{{-1, REDUCE, 134}, },
			{{-1, ERROR, 355}, {27, SHIFT, 361}, },
			{{-1, ERROR, 356}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, ERROR, 357}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, REDUCE, 51}, },
			{{-1, ERROR, 359}, {27, SHIFT, 364}, },
			{{-1, ERROR, 360}, {2, SHIFT, 54}, {11, SHIFT, 55}, {14, SHIFT, 56}, {15, SHIFT, 57}, {20, SHIFT, 58}, {22, SHIFT, 59}, {24, SHIFT, 60}, {46, SHIFT, 61}, {48, SHIFT, 62}, {49, SHIFT, 63}, {51, SHIFT, 64}, {53, SHIFT, 65}, {54, SHIFT, 66}, {57, SHIFT, 67}, {58, SHIFT, 68}, {60, SHIFT, 69}, {64, SHIFT, 70}, {67, SHIFT, 19}, {68, SHIFT, 71}, {69, SHIFT, 72}, },
			{{-1, REDUCE, 52}, },
			{{-1, REDUCE, 53}, {27, SHIFT, 191}, },
			{{-1, REDUCE, 54}, {27, SHIFT, 191}, },
			{{-1, REDUCE, 25}, },
			{{-1, REDUCE, 138}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 11}, {0, 2}, },
			{{-1, 73}, {4, 20}, {5, 21}, {7, 22}, {39, 52}, {43, 105}, {47, 118}, {51, 121}, {56, 126}, {103, 178}, {170, 52}, {171, 243}, {181, 257}, {235, 52}, {239, 52}, {242, 52}, {244, 52}, {246, 52}, {253, 52}, {287, 52}, {297, 52}, {298, 52}, {299, 52}, {306, 52}, {328, 52}, },
			{{-1, 239}, {175, 249}, {176, 250}, {235, 287}, },
			{{-1, 188}, },
			{{-1, 123}, {99, 172}, {121, 186}, {243, 296}, },
			{{-1, 12}, {17, 30}, },
			{{-1, 13}, },
			{{-1, 106}, },
			{{-1, 107}, },
			{{-1, 108}, },
			{{-1, 109}, },
			{{-1, 110}, },
			{{-1, 111}, },
			{{-1, 112}, },
			{{-1, 113}, },
			{{-1, 256}, },
			{{-1, 14}, {18, 33}, {31, 33}, },
			{{-1, 240}, {39, 53}, {235, 288}, {239, 292}, {287, 320}, },
			{{-1, 25}, {276, 317}, },
			{{-1, 26}, {23, 38}, {211, 282}, },
			{{-1, 15}, },
			{{-1, 241}, {242, 295}, {297, 295}, {299, 295}, {306, 295}, {328, 295}, },
			{{-1, 173}, {104, 179}, {172, 245}, {301, 332}, {302, 334}, {349, 359}, },
			{{-1, 48}, {46, 115}, {119, 184}, {182, 115}, },
			{{-1, 116}, {182, 258}, },
			{{-1, 49}, {42, 98}, {135, 194}, {177, 251}, {252, 304}, {322, 345}, {323, 346}, },
			{{-1, 117}, },
			{{-1, 260}, },
			{{-1, 16}, },
			{{-1, 133}, {40, 74}, {58, 130}, {59, 131}, {63, 137}, {67, 143}, {68, 144}, {136, 195}, {165, 232}, {167, 233}, {174, 247}, {191, 264}, {192, 265}, {196, 268}, {201, 273}, {205, 277}, {212, 283}, {267, 311}, {269, 312}, {270, 313}, {274, 315}, {300, 330}, {314, 339}, {318, 341}, {319, 342}, {338, 353}, {340, 354}, {356, 131}, {357, 131}, {360, 365}, },
			{{-1, 75}, },
			{{-1, 76}, {150, 216}, {151, 217}, {152, 218}, {153, 219}, {154, 220}, {155, 221}, },
			{{-1, 77}, {149, 215}, },
			{{-1, 78}, {156, 222}, {157, 223}, },
			{{-1, 79}, {158, 224}, {159, 225}, },
			{{-1, 80}, {160, 226}, {161, 227}, {162, 228}, },
			{{-1, 81}, {55, 124}, {57, 129}, {163, 229}, },
			{{-1, 82}, },
			{{-1, 83}, {56, 127}, },
			{{-1, 168}, {83, 166}, {127, 166}, },
			{{-1, 84}, {55, 125}, {56, 128}, {57, 125}, {149, 125}, {150, 125}, {151, 125}, {152, 125}, {153, 125}, {154, 125}, {155, 125}, {156, 125}, {157, 125}, {158, 125}, {159, 125}, {160, 125}, {161, 125}, {162, 125}, {163, 125}, },
			{{-1, 85}, },
			{{-1, 134}, {148, 214}, {164, 231}, },
			{{-1, 86}, },
			{{-1, 87}, },
			{{-1, -1}, },
			{{-1, 88}, },
			{{-1, 198}, {142, 202}, {275, 316}, },
			{{-1, 203}, },
			{{-1, 89}, },
			{{-1, 206}, {208, 278}, },
			{{-1, 207}, {208, 279}, },
			{{-1, 90}, },
			{{-1, 91}, },
			{{-1, 92}, },
			{{-1, 93}, },
			{{-1, 94}, },
			{{-1, 141}, {139, 199}, {200, 272}, },
			{{-1, 95}, },
			{{-1, 147}, {145, 209}, {210, 281}, },
			{{-1, 96}, },
			{{-1, 132}, {356, 362}, {357, 363}, },
			{{-1, 97}, {120, 185}, {169, 234}, {183, 261}, {266, 310}, },
			{{-1, 17}, },
			{{-1, 18}, {17, 31}, },
			{{-1, 242}, {244, 297}, {246, 299}, {253, 306}, {298, 328}, },
			{{-1, 208}, },
			{{-1, 200}, },
			{{-1, 210}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: 'module'",
			"expecting: unqualified identifier",
			"expecting: EOF",
			"expecting: 'generic', 'method', 'end.', 'module', 'import', 'define', 'function', 'type'",
			"expecting: 'generic', 'method', 'end.', 'module', 'define', 'function', 'type', EOF",
			"expecting: 'constant', unqualified identifier",
			"expecting: 'generic', 'method', 'end.', 'module', 'define', 'function', 'type'",
			"expecting: publicity modifier, '*', '/', '+', '-', 'and', 'or', 'xor', '^', '->', 'generic', 'method', ',', ':=', '(', ')', '{', '}', '[', ']', '.', ';', 'end.', 'module', '<', '>', 'define', 'constructor', 'destructor', '=', '<>', '>=', '<=', 'function', 'until', 'case', 'except', 'finally', 'else', '&', 'type', unqualified identifier",
			"expecting: '.', unqualified identifier",
			"expecting: '(', '.'",
			"expecting: '.', ';'",
			"expecting: '&'",
			"expecting: ':='",
			"expecting: ';'",
			"expecting: '('",
			"expecting: '='",
			"expecting: '&', unqualified identifier",
			"expecting: boolean constant, '-', '@', 'not', '(', '{', '[', 'lambda', 'while', 'do', 'for', 'cond', 'let', 'try', 'throw', 'cast', 'null', unqualified identifier, integer constant, string constant",
			"expecting: 'class', 'subrange', 'enum', 'exception', 'function', 'closure', unqualified identifier",
			"expecting: 'generic', unqualified identifier",
			"expecting: ',', ')', unqualified identifier",
			"expecting: ',', ')'",
			"expecting: ':=', ')', '[', '.', ';', '<'",
			"expecting: ':=', ')'",
			"expecting: publicity modifier, '*', '/', '+', '-', 'and', 'or', 'xor', '^', '->', ',', ')', '}', ']', ';', '<', '>', 'constructor', 'destructor', '=', '<>', '>=', '<=', 'until', 'case', 'except', 'finally', 'else', '&', unqualified identifier",
			"expecting: boolean constant, '-', '@', 'not', '(', '[', 'lambda', 'null', unqualified identifier, integer constant, string constant",
			"expecting: '(', unqualified identifier",
			"expecting: '{', 'case'",
			"expecting: publicity modifier, '*', '/', '+', '-', 'and', 'or', 'xor', '^', '->', ',', ':=', '(', ')', '}', '[', ']', '.', ';', '<', '>', 'constructor', 'destructor', '=', '<>', '>=', '<=', 'until', 'case', 'except', 'finally', 'else', '&', unqualified identifier",
			"expecting: ')', ';'",
			"expecting: publicity modifier, ',', ')', '}', ']', ';', 'constructor', 'destructor', 'until', 'case', 'except', 'finally', 'else', '&', unqualified identifier",
			"expecting: publicity modifier, '->', ',', ')', '}', ']', ';', '<', '>', 'constructor', 'destructor', '=', '<>', '>=', '<=', 'until', 'case', 'except', 'finally', 'else', '&', unqualified identifier",
			"expecting: publicity modifier, '+', '-', '->', ',', ')', '}', ']', ';', '<', '>', 'constructor', 'destructor', '=', '<>', '>=', '<=', 'until', 'case', 'except', 'finally', 'else', '&', unqualified identifier",
			"expecting: publicity modifier, '*', '/', '+', '-', '->', ',', ')', '}', ']', ';', '<', '>', 'constructor', 'destructor', '=', '<>', '>=', '<=', 'until', 'case', 'except', 'finally', 'else', '&', unqualified identifier",
			"expecting: publicity modifier, '*', '/', '+', '-', 'and', 'or', 'xor', '->', ',', ')', '}', ']', ';', '<', '>', 'constructor', 'destructor', '=', '<>', '>=', '<=', 'until', 'case', 'except', 'finally', 'else', '&', unqualified identifier",
			"expecting: publicity modifier, '*', '/', '+', '-', 'and', 'or', 'xor', '^', '->', ',', '(', ')', '}', '[', ']', ';', '<', '>', 'constructor', 'destructor', '=', '<>', '>=', '<=', 'until', 'case', 'except', 'finally', 'else', '&', unqualified identifier",
			"expecting: publicity modifier, '*', '/', '+', '-', 'and', 'or', 'xor', '^', '->', ',', ':=', ')', '}', '[', ']', ';', '<', '>', 'constructor', 'destructor', '=', '<>', '>=', '<=', 'until', 'case', 'except', 'finally', 'else', '&', unqualified identifier",
			"expecting: '{', '<', 'extends'",
			"expecting: 'extends'",
			"expecting: 'generic', 'method', '.', 'end.', 'module', 'define', 'function', '&', 'type'",
			"expecting: ',', ')', '.'",
			"expecting: '{'",
			"expecting: ':=', ')', '[', ';'",
			"expecting: publicity modifier, '*', '/', '+', '-', 'and', 'or', 'xor', '^', '->', ',', ')', '}', '[', ']', ';', '<', '>', 'constructor', 'destructor', '=', '<>', '>=', '<=', 'until', 'case', 'except', 'finally', 'else', '&', unqualified identifier",
			"expecting: publicity modifier, '*', '/', '+', '-', 'and', 'or', 'xor', '^', '->', ',', ')', '}', '[', ']', '.', ';', '<', '>', 'constructor', 'destructor', '=', '<>', '>=', '<=', 'until', 'case', 'except', 'finally', 'else', '&', unqualified identifier",
			"expecting: '['",
			"expecting: ')'",
			"expecting: publicity modifier, '}', ';', 'constructor', 'destructor', '&', unqualified identifier",
			"expecting: '}', ';'",
			"expecting: ',', ')', ']'",
			"expecting: ',', ']'",
			"expecting: 'until'",
			"expecting: 'case'",
			"expecting: 'except', 'finally'",
			"expecting: 'else'",
			"expecting: boolean constant, '-', '@', 'not', '(', ')', '{', '[', 'lambda', 'while', 'do', 'for', 'cond', 'let', 'try', 'throw', 'cast', 'null', unqualified identifier, integer constant, string constant",
			"expecting: publicity modifier, 'constructor', 'destructor', '&', unqualified identifier",
			"expecting: '{', 'extends'",
			"expecting: 'or', ';'",
			"expecting: '{', ';'",
			"expecting: ',', '>'",
			"expecting: publicity modifier, '*', '/', '+', '-', 'and', 'or', 'xor', '^', '->', 'generic', 'method', ',', ')', '}', ']', ';', 'end.', 'module', '<', '>', 'define', 'constructor', 'destructor', '=', '<>', '>=', '<=', 'function', 'until', 'case', 'except', 'finally', 'else', '&', 'type', unqualified identifier",
			"expecting: '}', 'case'",
			"expecting: publicity modifier, '->', ',', ')', '}', ']', ';', 'constructor', 'destructor', 'until', 'case', 'except', 'finally', 'else', '&', unqualified identifier",
			"expecting: ']'",
			"expecting: ',', '[', '.', '<', '&', unqualified identifier",
			"expecting: ',', '&', unqualified identifier",
			"expecting: publicity modifier, '}', 'constructor', 'destructor', '&', unqualified identifier",
			"expecting: '{', '.', ';', '<'",
			"expecting: ','",
			"expecting: 'null'",
			"expecting: ':=', ')', '{', '[', ';', 'extends'",
			"expecting: integer constant",
			"expecting: ';', 'extends'",
			"expecting: ',', ')', '&', unqualified identifier",
			"expecting: '}', 'case', 'else'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 2, 3, 1, 1, 4, 1, 5, 1, 1, 6, 3, 6, 6, 6, 6, 3, 6, 7, 8, 9, 10, 1, 11, 12, 13, 14, 15, 4, 3, 6, 4, 6, 1, 14, 1, 3, 13, 16, 17, 6, 1, 18, 4, 7, 19, 20, 21, 21, 6, 1, 22, 23, 24, 25, 26, 25, 17, 17, 17, 14, 14, 17, 14, 27, 14, 17, 17, 27, 24, 24, 24, 28, 29, 30, 31, 32, 33, 34, 24, 24, 24, 35, 36, 24, 24, 24, 30, 30, 30, 30, 30, 30, 30, 30, 30, 30, 21, 37, 14, 14, 14, 26, 38, 39, 6, 6, 6, 6, 6, 6, 6, 6, 1, 21, 21, 21, 40, 1, 41, 22, 1, 42, 24, 43, 44, 45, 43, 24, 46, 47, 48, 49, 50, 1, 17, 51, 1, 52, 14, 30, 1, 53, 30, 52, 14, 54, 55, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 25, 55, 17, 36, 17, 36, 41, 56, 1, 57, 41, 17, 1, 1, 1, 9, 41, 58, 1, 19, 59, 21, 6, 42, 60, 60, 35, 61, 17, 17, 24, 21, 46, 17, 12, 13, 62, 62, 17, 29, 29, 14, 17, 53, 30, 53, 62, 62, 1, 17, 24, 21, 32, 63, 63, 63, 63, 63, 63, 33, 33, 34, 34, 24, 24, 24, 24, 24, 21, 64, 30, 6, 16, 1, 1, 65, 66, 45, 67, 67, 68, 56, 41, 56, 69, 21, 21, 21, 21, 1, 67, 70, 6, 13, 40, 21, 6, 6, 6, 1, 71, 47, 49, 41, 17, 30, 17, 17, 30, 62, 46, 17, 1, 1, 30, 53, 30, 54, 62, 46, 30, 24, 24, 36, 66, 45, 14, 14, 1, 13, 72, 6, 67, 59, 67, 56, 67, 17, 73, 73, 13, 21, 6, 67, 13, 6, 60, 24, 30, 29, 13, 17, 30, 29, 46, 17, 17, 13, 72, 1, 1, 74, 67, 64, 6, 67, 6, 46, 6, 13, 6, 13, 6, 13, 6, 17, 30, 17, 30, 75, 67, 64, 21, 21, 13, 6, 38, 6, 6, 6, 46, 53, 13, 17, 17, 67, 13, 17, 67, 47, 47, 6, 30, 
        };*/

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Parser.class.getResourceAsStream("parser.dat")));

            // read actionTable
            int length = s.readInt();
            Parser.actionTable = new int[length][][];
            for(int i = 0; i < Parser.actionTable.length; i++)
            {
                length = s.readInt();
                Parser.actionTable[i] = new int[length][3];
                for(int j = 0; j < Parser.actionTable[i].length; j++)
                {
                for(int k = 0; k < 3; k++)
                {
                    Parser.actionTable[i][j][k] = s.readInt();
                }
                }
            }

            // read gotoTable
            length = s.readInt();
            gotoTable = new int[length][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][2];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                for(int k = 0; k < 2; k++)
                {
                    gotoTable[i][j][k] = s.readInt();
                }
                }
            }

            // read errorMessages
            length = s.readInt();
            errorMessages = new String[length];
            for(int i = 0; i < errorMessages.length; i++)
            {
                length = s.readInt();
                StringBuffer buffer = new StringBuffer();

                for(int j = 0; j < length; j++)
                {
                buffer.append(s.readChar());
                }
                errorMessages[i] = buffer.toString();
            }

            // read errors
            length = s.readInt();
            errors = new int[length];
            for(int i = 0; i < errors.length; i++)
            {
                errors[i] = s.readInt();
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
        }
    }
}
